#define AVOID_WORDS_LONGER_THAN 25
// You may want to change this one. AVOID_WORDS_LONGER_THAN is used to
// avoid garbage data like PGP-blocks and BINHEX things. It also
// filters out a whole lot of other garbage that doesn't fit in the
// database

#define DEBUG 1
// Set to one to get debug information to stdout (ie roxen debug log)
//

#define DEFAULT_SUMMARY_TEXT_LENGTH 128
// This is the length of the sample text
// (summary) displayed at search results.

#define MAX_TITLE_LENGTH 80
// Titles longer than this are cut off!

#define DEFAULT_WALK_DELAY 0
// New (Or if undefined) crawler default for walk delay.

#define DEFAULT_QUOTED_ACTIVATED "1"

#define DEFAULT_GLOB_ACTIVATED "1"

#define DEFAULT_NICE_INCREMENT 0
// New (Or if undefined) crawler default for nice increment.

#define NICE_MAX 19
// Max value for nice inc's.

#define NICE_MIN -19
// Min value for nice inc's.

#define AGENT_IDENTIFICATION  "User-Agent: Intraseek_1"
// The robot will identify itself as this.

#define AGENT_HOST "host: "
// Leave untouched.

#define AGENT_FROM "from: "
// Leave untouched.

#define CRAWLER_ID "intraseek"
// Leave untouched.

#define DEFAULT_CHARSET "iso-8859-1"
// Leave unchanged...

#define ACCEPT_REQ_FIELD "Accept: text/plain: q=0.5, text/html"
// Leave untouched.

#define PREFIX_LOCATION "Location: "
// Leave untouched.

#define PREFIX_CONTENT_LENGTH "Content-length: "
// Leave untouched.

#define PREFIX_CONTENT_TYPE "Content-type: "
// Leave untouched.

#define REQ_OK 200
// Leave untouched.

#define REQ_REDIRECT 302
// Leave untouched.

#define REQ_FORBIDDEN 403
// Leave untouched.

#define REQ_NOTFOUND 404
// Leave untouched.

#define CRLF "\r\n"
// Leave untouched.

#define CR "\r"
// Leave untouched.

#define LF "\n"
// Leave untouched

#define MAX_DATA_READ 99999
// Leave untouched.
// MAX_DATA_READ only for robots. No robot.txt should exceed this size!

#define DELI ""
// Leave untouched!
// Delimiter. Filtered out from just about everything and used
// as separator in data structures.

#define FILTER_OUT ({ "$$", "##", "++", "xxx", "|_|", "=-", "aaa", "-+-", "__", "--", "==" })  
// You might want to add other 'garbage' data to this array of
// uninteresting stuff.

#define TIME_SUBSTRACT 800000000
// Leave untouched.

#define BLOCK 16060
// Leave untouched. Amount of data moved in one operation. This def
// applies to database daemon only.

#define IND_BLOCK 10000
// Leave untouched. Amount of data moved in one operation. This def
// applies to restoring database.

#define FIND_MAX 32676 
// Leave untouched. Amount of data blocking read by the find agent.

#define PS_MEM_COMMAND ps
// Leave untouched.

#define RUNNING 0
// Leave untouched.

#define ERR_REDIRECT -2
#define ERR_CON_FAIL -3
#define ERR_FORBIDDN -4
#define ERR_NOTFOUND -5
#define ERR__ERR_URL -6
#define ERR__UNKNOWN -7
#define ERR__ILLEGAL -8
// Leave all these ERR_'s untouched.

#define DEFAULT_AVOID "standard.avoid"
//  Leave untouched.

#define DEFAULT_WORKING_AT "/tmp/"
//  Leave untouched.

#define DEFAULT_SAFETY_SAVE 500
//  Leave untouched.

#define DEFAULT_MAX_DOC_DL 10000
//  Leave untouched.

#define DEFAULT_MAX_BYTES_FETCH 100000
//  Leave untouched.

#define DEFAULT_STOPLIST "minimal.stop"
//  Leave untouched.

#define DEFAULT_QUERY_LOG_MAX_SIZE 100000
//  Leave untouched

#define DEFAULT_QUERY_LOG_ACTIVATED "1"
//  Leave untouched

#define DEFAULT_STRUC_LOG_LOG_ACTIVATED "1"
//  Leave untouched

#define DEFAULT_PROFILE_ACTIVATED "1"
//  Leave untouched

#define DEFAULT_CRAWLER_LOG_LEVEL 0
//  Leave untouched

#define DEFAULT_SCHEDULE_1 0
//  Leave untouched

#define DEFAULT_SCHEDULE_2 1
//  Leave untouched

#define DEFAULT_SCHEDULE_3 2
//  Leave untouched


#define LOG_LEVEL_FULL 0
//  Leave untouched

#define LOG_LEVEL_MEDIUM 1
//  Leave untouched

#define LOG_LEVEL_SHORT 2
//  Leave untouched

#define LOG_LEVEL_NONE 3
//  Leave untouched

#define DEFAULT_CUTOFF 2000
//  Leave untouched

#define DEFAULT_TIMEOUT 300
//  Leave untouched

#define PROFILES_DELI "$"
//  Leave untouched.

#define _FETCHERID 0
//  Leave untouched.

#define _TEXT_BODY 1
//  Leave untouched.

#define _TEXT_TITL 2
//  Leave untouched.

#define _URLS_VISI 3
//  Leave untouched.

#define _NEW_URLS_ 4
//  Leave untouched.

#define _METAINFO_ 5
//  Leave untouched.

#define _SIZEOFDOC 6
//  Leave untouched.

#define _SUMMARY__ 7
//  Leave untouched.

#define _CHARSET__ 8
//  Leave untouched.

#define _DATE_____ 9
//  Leave untouched.

#define DEFAULT_QUICK_LINKS 20
//  Leave untouched.

#define DEFAULT_ENTIRES 10
//  Leave untouched.
