//
// This source-code is a part of the Roxen IntraSeek search engine package.
//  1996-1998 Idonex AB
// Email: info@idonex.se 
//
// Intraseek Filter: HTML
//
//
// Removes HTML stuff from a file, saves the URL's for later stacking use
//
// array filter(string file, string site, string uri, int port,
// 	     string protocol, int summary_text_length)
// {
//   return
//     ({ array links, string body, string title, string metadata,
//        string summary,string charset, int index, int follow });
// }

constant wanted_contenttypes = ({ "text/plain", "text/html" });


#include <simulate.h>
#include "../crawler.h"

import spider;

int j,k,l,m,n;
string body, title, hidden;

string *newlinks;
string *new2;

string *uriparts;
string first_part_of_uri;
string meta;

string rawtext;
string site;
string uri;
int port;
string protocol;

int global_follow, global_index;
string global_charset;
string global_summary;

void modify_links()
{
  int i,k;
  string temp;
  string newurl;
  string tempfirstpart;
  string rem;

  uriparts=explode(uri, "/");

  if (sizeof(uriparts))
    first_part_of_uri=implode(uriparts[0..(sizeof(uriparts)-2)], "/")+"/";
  else
    first_part_of_uri=uri;


  for (i=0; i<sizeof(newlinks); i++)
  {
    newurl=newlinks[i];
    if (newurl)
    {

      tempfirstpart=first_part_of_uri;
      newurl=replace(newurl,"\n","");
      rem=newurl;
      k=sscanf(newurl, "%s#", newurl);

      // If this is an anchor like "<a href="#xxx"> WITHIN the current doc...
      // there is no need to do anything else
      if (!((k) && (newurl==""))) 
      {
	  
	if(-1!=search(newurl, "./"))
	{
	  newurl=combine_path(first_part_of_uri, newurl);   // Remove all ..'s and such
	  tempfirstpart="";
	}

	// Obviously, this is also a way to write http://  (grr)
	if(newurl[0..1]=="//")  
	  newurl="http:"+newurl;
	if((sizeof(newurl)<5) || (newurl[0..4]!="http:"))
	  if(newurl[0..0]=="/")
	    newurl=protocol+"://"+site+(port!=80?":"+port:"")+newurl;
	  else 
	    newurl=protocol+"://"+site+(port!=80?":"+port:"")+"/"+tempfirstpart+newurl;
	
	m=sizeof(newurl);
	while(search(newurl, "//", 7)!=-1)
	{
	  temp=newurl[0..6];
	  // Remove double //'s
	  newurl=temp+replace(newurl[7..sizeof(newurl)], "//", "/");   
	}

	// Add a traling / for site-urls'!!!!
	if(-1==search(newurl, "/", 7))
	  newurl+="/";                       

	new2+=({newurl});
      }
    }
  }
}
 

string zap_html_type_comments(string data)
{
  string *x=data/"<!--";
  string ret=x[0];
  for(int e=1;e<sizeof(x);e++)
  {
    sscanf(x[e],"%*s-->%s",x[e]);  // Kan ersttas med intelligentare skning 
    ret+=x[e];
  }
  return ret;
}

string remove_ltgt(string from)
{
  string s;
  array res=({});
  foreach(from/"<", from)
    {
      sscanf(from, "%*s>%s", from);
      res += ({ from });
    }
  return res * "";
}

void handle_href(string test)
{
  newlinks += ({ ""+test });
}


void handle_title(string test)
{
//  title=lower_case(test);  NONO!
  title=test;
  if(title=="0")
    title="";  // Jens-work-around.
}


string insert_spacues()
{
  return " ";
}

string parse_href(string tag, mapping args, string contents)
{
//  werror("parse_href: %O",args->href+args[""]);
  if(args->href && (-1==search(lower_case((args->href)||""), "mailto")))
    handle_href(args->href);
  return contents;
}

string parse_title(string tag, mapping args, string contents)
{
  handle_title(contents);
  return "";
}

// Dublin core URL: http://linnea.helsinki.fi/meta/dcdraft.html

int my_smallest(int a, int b)
{
  if(a==-1) a=0;
  if(b==-1) b=0;
  if ((a==0) && (b==0)) return 0;
  if (a==0) return b;
  if (b==0) return a;
  if (a<b) return a;
  return b;
}

string check_charset_in_content(string content)
{
  int end,start;
  if (((start=search(content,"charset="))!=-1) &&
      (end=my_smallest(search(content, CR, (start+8)),
		       (my_smallest(search(content, LF, (start+8)),
				    search(content, ";", (start+8)))))))
    return lower_case(content[(start+8)..(end-1)]);
  return "";
}

string parse_meta(string tag, mapping args)
{
  string temporar;
  string content;
  string *lista;
  if (args["http-equiv"])
  {
    if (lower_case((args["http-equiv"]))=="content-type")
    {
      content=args["content"];
      if ((content) && (content!=""))
	global_charset=check_charset_in_content(content+";");
    }
  }
  
  temporar=args->name;
  if((!temporar) || (temporar==""))
  {
    return "";
  }
  temporar=lower_case(temporar);
  content=(args->content);
  
  switch (temporar) {
   case "keywords" : 
    if ((content) && (content!=""))
      meta+=" "+lower_case(args->content);
    break;
   case "description" : 
    if ((content) && (content!=""))
      global_summary=(args->content);
    break;
   case "dc.subject" :
    if ((content) && (content!=""))
      meta+=" "+lower_case(args->content);
    break;
   // As seen on http://www.ub2.lu.se/desire/radar/reports/D3.11/f_3.html
   case "robots" :  
    if ((content) && (content!=""))
    {
      content=lower_case(replace(content," ",","));
      lista=explode(content, ",");
      if (member_array("none", lista)!=-1)
      {
	global_follow=0;
	global_index=0;
      }
      if (member_array("all", lista)!=-1)
      {
	global_follow=1;
	global_index=1;
      }
      if (member_array("follow", lista)!=-1)
      {
	global_follow=1;
      }
      if (member_array("nofollow", lista)!=-1)
      {
	global_follow=0;
      }
      if (member_array("index", lista)!=-1)
      {
	global_index=1;
      }
      if (member_array("noindex", lista)!=-1)
      {
	global_index=0;
      }
    }
  }
}

string handle_frame(string tag, mapping args)
{
  if(args->src)
    handle_href(args->src);
  return " ";
}

string parse_img_alt(string tag, mapping args)
{
  string temporar;
  temporar=args->alt;
  if((!temporar) || (temporar==""))
    return "";
  hidden=hidden+" "+lower_case(temporar);
  return " ";
}

string parse_area_alt_and_links(string tag, mapping args)
{
  string temporar;
  temporar=args->alt;
  if((!temporar) || (temporar==""))
    temporar="";
  else
    temporar=" "+lower_case(temporar)+" ";
  if(args->href && (-1==search(lower_case(args->href||""), "mailto")))
    handle_href(args->href);
  hidden=hidden+" "+lower_case(temporar);
  return " ";
}

void no_index_dehtml_process_text(string what)
{
  // This is a version of dehtml_process_text() found below.
  // This one doesnt care about what happens with the text
  // its only purpose is to find new links and handle meta data hidden within a no_index tag.
  parse_html(what,
	     ([ "area":parse_area_alt_and_links,
		"meta":parse_meta,
		"frame":handle_frame
	     ]),
	     ([ "a":parse_href,
		"title":parse_title,
	     ]));
}

string parse_noindex(string tag, mapping args, string contents)
{
  if (!(args->nofollow))
    no_index_dehtml_process_text(contents);
  return "";
}

string dehtml_process_text(string what)
{
// Removes all tags, handle new files, and add some weight to strings
// in other tags.
  return remove_ltgt(parse_html(what,
				(["center":insert_spacues, "hr":insert_spacues,
				  "img":parse_img_alt, "p":insert_spacues,
				  "br":insert_spacues, "tr":insert_spacues,
				  "td":insert_spacues, "area":parse_area_alt_and_links,
				  "meta":parse_meta, "frame":handle_frame]),
				(["a":parse_href,
				  "title":parse_title,
				  "no_index":parse_noindex,
				  "no-index":parse_noindex 
				])));
}

string fix_summary_html(string what)
{
  string temp;
   temp=remove_ltgt(parse_html(what, (["center":insert_spacues,
				       "hr":insert_spacues,
				       "img":insert_spacues,
				       "p":insert_spacues,
				       "br":insert_spacues,
				       "tr":insert_spacues,
				       "td":insert_spacues,
				       "area":insert_spacues,
				       "meta":insert_spacues,
				       "frame":insert_spacues]),
			             (["no_index":parse_noindex,
				       "no-index":parse_noindex]) ));
  return replace(temp, ({DELI, "\n", "\r", "\t"}), ({""," ", " ", " "}));
}

string create_summary_text(string textbody, int summary_text_length) 
{
  // Sample text is what is displayed as search result summaries.
  //
  string temp;
  string *temp2;
  temp=textbody[0..(summary_text_length+65535)];
  temp=fix_summary_html(temp);
  temp2=explode(temp, " ");
  temp2=temp2-({""});
  temp=implode(temp2, " ");
  temp=capitalize(temp[0..summary_text_length]+"...");
  return temp;
}


array filter(string file, string xsite, string xuri, int xport,
	     string xprotocol, int summary_text_length)
{
  hidden="";
  rawtext=file;
  site=xsite;
  uri=xuri;
  port=xport;
  protocol=xprotocol;
  new2=newlinks=({});
  meta="";
  title="(Untitled)";
  global_follow=global_index=1;
  global_summary=global_charset="";

  rawtext=zap_html_type_comments(rawtext);
  body=dehtml_process_text(rawtext);

  if (global_summary=="")
    global_summary=create_summary_text(body, summary_text_length);
  else
  {
    global_summary=global_summary[0..summary_text_length]+"...";
    global_summary=fix_summary_html(global_summary);
  }

  // Stuff from img alt definitions, and such. They should also be indexed.
  body=body+hidden;  
  modify_links();

  if(global_follow)
    newlinks=new2;
  else
    newlinks=({});
  
  if ((!title) || (title==""))
    title="";
  
  return
    ({ newlinks, 
       body, 
       title,       
       meta,
       global_summary,
       global_charset,
       global_index,
       global_follow
    });
}
