// This source-code is a part of the Roxen IntraSeek search engine package.
//  1996-1998 Idonex AB
// Email: info@idonex.se 
//
// Intraseek Filter: RTF

constant wanted_contenttypes = ({ "application/rtf" });
constant cvs_version = "$Id $";

array filter(string file, string site, string uri, int port,
 	     string protocol, int summary_text_length)
{
  string s="";
  int start,end;
  string title="",hiascii;
  sscanf(file,"{\\title %s}",title);

  array doc = file[search(file,"\\pard")..] / "\\pard";
  for(int i=0;i<sizeof(doc);i++)
  {
    doc[i]=replace(doc[i],({ "\n", "\r" }), ({ "", ""}));
    
    // decode hex-encoded characters
    while((start=search(doc[i],"\\'"))!=-1)
    {
      hiascii="";
      if(doc[i][start+1..start+1]=="'")
      {
	int hichar;
	if(sscanf(doc[i][start+1..start+3],"'%x",hichar))
	  hiascii=sprintf("%c",hichar);
	end=start+3;
	doc[i]=doc[i][..start-1]+hiascii+doc[i][end+1..];
      }
    }
    
    array curr_par=replace(doc[i],({ "{", "}", "\\"}),
			   ({ "\0{\0", "\0}\0", "\0\\\0"})) / "\0";

    // tokenize paragraph
    for(int n=0;n<sizeof(curr_par);n++)
    {
      if((curr_par[n]=="\\") && n<(sizeof(curr_par)-1))
      {
	start=search(curr_par[n+1]," ");
	if(start!=-1)
	{
	  curr_par[n]+=curr_par[n+1][..start-1];
	  curr_par[n+1]=curr_par[n+1][start+1..];
	}
	else
	{
	  curr_par[n]+=curr_par[n+1];
	  curr_par[n+1]="";
	}
      }
    }
    
    foreach(curr_par,string foo)
      if((foo[0..0]!="\\") && sizeof(foo)>0)
	s+=foo;
    
  }
  return ({ ({}), s, title, "", s[..summary_text_length], "", 1, 1 });
}

