#!NOMODULE
//
// This source-code is a part of the Roxen IntraSeek search engine package.
//  1996-1998 Idonex AB
// Email: info@idonex.se
//
//
// The pike need parse_sgml and Yabu to be able to run this!
//

#if constant(Process.create_process)
import ".";
#endif
#include "Crawler.pmod/crawler.h"

import Stdio;


int start_time;
string robot_home,profiles_base;



#define QUERY_LOG_DETAIL profile_handler->crawler_log_detail

function nice=
#if constant(nice)
  predef::nice
#else
  lambda(int arg){}
#endif
;

void crawlerlog(string txt)
{
  write_file(robot_home+"logs/crawler.log", txt+"\n");
}

int main(int argc, string *argv)
{
  int i;
  int restore=0;
  
  string temp="";

  program control;
  program profile_code;
  object profile_handler;
  object controller;
  mapping junk;
  
  array err;

  object rpc;
  if(argc==9)
  {
    //  ({ host, port, rpckey })
    array rpcinfo=decode_value(MIME.decode_base64(argv[8])); 
    rpc=RoxenRPC.Client(@rpcinfo);
  }
  
  start_time=time();
  
  // Profile handle
  // Takes arguments   restore||"" , profile name, robot base path,
  // profiles base path, admin email address.
  
  if (argv[1]=="restore")
    restore=1;
  
  string profil=argv[2];
  robot_home=argv[3];
  profiles_base=argv[4];
  string admin=argv[5];
  
  string defworld=argv[6];
  string defaccept=argv[7];
  
  if((!profil) || profil=="")
  return 0;
  
  
  profile_handler=Crawler.profile();

  profile_handler->set_robot_home(robot_home);
  profile_handler->set_all_robots_from(admin);
  profile_handler->load_and_parse_profiles(profiles_base,"profiles.txt");
  profile_handler->set_fall_back_world(profil, defworld);
  profile_handler->set_fall_back_accept(profil, defaccept);
  profile_handler->compile_all_regexps();
  
  if(!(profile_handler->get_profile(profil)))
  {
    crawlerlog("The profile specified ("+profil+") wasn't defined in "+
	       profiles_base+"profiles.txt\n");
    return 0;
  }
  
  crawlerlog("Crawler: Starting "+profil+" crawler at "+ctime(time()));
  profile_handler->delete_log(profil);
  
  if (QUERY_LOG_DETAIL(profil)<LOG_LEVEL_NONE)
  profile_handler->log(profil, "Crawler: Starting A Webcrawler! I have PID="+getpid()+".");
  profile_handler->create_robot_id(profil, (""+getpid()), ""+time(), "0", RUNNING);
  
  profile_handler->log(profil, ("Crawler: Running with "
				"nice value: "+((profile_handler->nice_increment(profil))?
						(profile_handler->nice_increment(profil)):
						"Normal (0)")+".\n"));
  
  controller=Crawler.control();
  controller->set_robot_home(robot_home);
  
  if (restore)
    controller->start_control("restore", profil, profile_handler,rpc);
  else
    controller->start_control("", profil, profile_handler,rpc);
  
  if (QUERY_LOG_DETAIL(profil)<LOG_LEVEL_NONE)
    profile_handler->log(profil, "Crawler: Done after "+
			 profile_handler->describe_time(time()-start_time)+".");
  
  return 0;
}
  
