#!NO

//
//
//
// This source-code is a part of the Roxen IntraSeek search engine package.
//  1996-1998 Informationsvvarna AB
// Email: info@idonex.se
//
// 
// Config interface for Intraseek.
//
//

//inherit "roxenlib";

#include "shared_help.h";

inherit "wizard";
inherit "roxenlib";

#define NOPIKE 2
#define STARTING 4
#define RUNNING 0
#define FINISHED 1
#define FREEZING 5
#define FROZEN 6
#define ERROR 7
#define DUMPING 8
#define XREFE 9

#define TIMEOUT 120
#define RUNNING_TIMEOUT 300
#define TO this_object()

#define COL1 "#113377"
#define COL2 "#ddeeff"
#define COL3 "#ffffff"
#define COL4 "#dddddd"
#define COL5 "#dddddd"
#define UNIT " <img width=2 height=2 src=\"internal-roxen-unit\"> "

#define TH(r) "<td bgcolor=\""+COL1+"\"><font color=white><b> "+r+" </b></font></td>"
#define BUT(l,t) "\n<table cellpadding=3><tr><td bgcolor=\""+COL4+"\"><b><a href=\""+l+"\"><font color=black><b> "+t+" </b></font></a></td></tr></table>"
#define RES(i) "<td bgcolor=\""+COL4+"\"><b> <a href=\""+my_world_total+(l_str[i])+http_encode_string(profile)+"\"><font color=black><b> "+l_tex[i]+" </b></font></a></td>"
#define BUT2(l,t) "<td bgcolor=\""+COL4+"\"><b>&nbsp; <a href=\""+my_world_total+l+"\"><font color=black><b> "+t+" </b></font></a>&nbsp;</td>"

#define TOMRES "<td>"+UNIT+"</td>"
#define BLACK1 "<table border=0 cellpadding=0 cellspacing=0 bgcolor=black>\n<tr><td>"
#define BLACK2 "</td></tr></table>\n"
#define WHITE1 "<table border=0 bgcolor=white width=100% cellpadding=4 cellspacing=1><td><td>"
#define WHITE2 "</td></tr></table>\n"

string my_world=0;
string my_world_total=0;
object rpc;
constant sched1=({ "Never!", "Weekly", "Biweekly", "First week every month" });
constant sched2=({ "Daily", "Mondays", "Tuesdays", "Wednesdays", "Thursdays",
		   "Fridays", "Saturdays", "Sundays" });
constant sched3=({ "00:00", "02:00", "04:00", "06:00", "08:00", "10:00",
		   "12:00", "14:00", "16:00", "18:00", "20:00", "22:00" });

void crawlerlog(string txt)
{
  Stdio.write_file(TO->engine_home+"logs/crawler.log", txt+"\n");
}

int str2int(string s)
{
  int k;
  if (s && s!="")
    if(-1==sscanf(s, "%d", k))
      return 0;
  return k;
}

string top(int which, string refresh, object id)
{
  string tem="",lnk;
  string *name=({ "Profiles", "Crawlers", "Logs" });
  string *link=({ "","crawler/","logs/" });
  string *xtratitel=({ "Profile configuration", "Crawlers", "Logs" });
  
  if(!id->misc->sb)
  {
    tem = "<html><head><title>Roxen Intraseek Configuration: "+xtratitel[which]+"</title>"
      "<META HTTP-EQUIV=\"Expires\" CONTENT=\"0\">\n";
    
    if (refresh!="")
      tem+="<META HTTP-EQUIV=Refresh CONTENT=\"15; URL="+refresh+"\">\n";
    
    tem+= "</head>\n"
      "<body bgcolor='#ffffff' text='#000000' "
      "link='#000070' vlink='#000070' alink='#ff000'>\n"
      "<table cellpadding=0 cellspacing=0 border=0 width='100%'>"
      "<tr><td valign=bottom align=left>"
      "<a \nhref=\"http://www.roxen.com/\">"
      "<img border=0 alt=\"Roxen\" src=/internal-roxen-roxen-icon-gray></a>"
      "</td><td>&nbsp;</td>\n<td width='100%' height=39>"
      "<table cellpadding=0 cellspacing=0 width='100%' border=0>"
      "<tr width='100%'><td width=100% align=right valigh=center height=28>"
      "<b>"+xtratitel[which]+"</b>"
      "</td></tr><tr width='100%'>"
      "<td bgcolor='#003366' align=right height=12 width='100%'>"
      "<font color=white size=-2>"+
      INTRASEEK_VERSION+"&nbsp;&nbsp;</font>"
      "</td></tr></table></td>\n"
      "</tr></table>\n<br>\n";
  }
  else
    tem="";

  string res_tabs="";
  for (int i; i<3; i++)
  {
    lnk=combine_path(link[i], "");
    lnk=link[i];
    mapping args = ([]);
    args->href = my_world_total+lnk;
    if(which==i)
      args->selected = "selected";
    res_tabs += make_container( "tab", args, name[i]);
  }
  tem += make_container("config_tablist",([]), res_tabs)+"<p>";
  
  return tem;
}

string size_of_file(string full_file_name)
{
  int *temporary;
  temporary=file_stat(full_file_name);
  if (temporary && (sizeof(temporary)>1))
    return sprintf("%2.1f Kb",((float)temporary[1]/(float)1000));
  else
    return "<font color=orange>No file</font>";
}

int file_last_modified(string full_file_name)
{
  int *temporary;
  temporary=file_stat(full_file_name);
  if (temporary && (sizeof(temporary)>1))
    return (int)temporary[3];
  else
    return -1;
}


string bottom()
{
  return "</body></html>\n\n";
}


string intro(string *profiles)
{
  int i,j, flip=1;
  string res="";
  string profile;

  if (!(TO->profile_handler))
  {
    TO->engine_reset(0);
    if (!(TO->profile_handler))
      return "Strange. No profile handler loaded. Is the path <tt>"+TO->engine_home+"</tt> the correct engine home location for IntraSeek?";
  }

  if(sizeof(profiles)>0)
  {
    res+="<obox spacing=200 right=50 title=\"Profile Overview\">"
      "<p>"+BLACK1+"<table width=100% border=0 cellspacing=1 cellpadding=4>"
      "<tr>"+TH("Profile")+TH("Full Name")+TH("Activated")+TH(UNIT)+"</tr>";
    
    foreach(sort(profiles), profile)
    {
      if(profile && profile!="")
	res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+">\n"
	  "<td> "+profile+" </td>"
	  "<td> "+(TO->profile_handler)->realname(profile)+" </td>"
	  "<td> "+((((TO->profile_handler)->active(profile))=="1")?"<font color=darkgreen>"
	  "<b>Yes</b></font>":"<font color=darkred><b>No")+"</b></font> </td>"
          BUT2("configure/"+http_encode_string(profile), "Edit")
	  "</tr>\n";
      
    }
    res+="</table>"+BLACK2+"<p>\n";
  }
  else
    res="&nbsp;&nbsp; <font color=darkred>You don't have any profiles configured yet, "
        "Please press the 'new profile wizard' link below to get started...</font>";
  res+="</obox>"+BLACK2+"<p>";
  res+=BUT(my_world_total+"wizard/?action=new.pike&unique="+time(), "New Profile Wizard");
  res+="</ul>";
  return res;
}
    

string do_view_status(string idt)
{
  string result;
  result="<obox title=\"Status for "+idt+"\">";
  if (!file_stat(TO->profile_handler->working_at(idt)+idt+".status.html"))
    result+="<font color=orange>No status file found at "+TO->profile_handler->working_at(idt)+idt+".status.html</font>";
  else
    result+=Stdio.read_bytes(TO->profile_handler->working_at(idt)+idt+".status.html");
  result+="</obox><p><font size=-1>(Note: This page will auto-refresh every 15 second. If it doesn't, you have to reload this page to update "
            "the crawler status information)</font><p>"+BUT("vlog/"+http_encode_string(idt),"Show entire crawler log");
  return result;
}

string do_view_log(string idt)
{
  return    "<ul><h2>Crawler log. (Reload this page to update it):</h2><hr><tt>"
            "<p>"+replace(html_encode_string(""+TO->profile_handler->view_log(idt)), ({"\n","Fetcher "}), ({"<br>", "<hr>Fetcher# "}))+"</tt></ul>";
}

void do_reset(string idt)
{
  TO->profile_handler->delete_robot_id(idt);
}

void do_zap(string idt)
{
  int pid;
  pid=(str2int(((TO->profile_handler)->load_robot_id(idt))["pid"]));
  crawlerlog("Zapping crawler for '"+idt+"', process number: "+pid+".");
  if (pid>0)
    kill (pid, signum("SIGKILL"));
  else
    crawlerlog("Process number zero, no process zap performed!");
  TO->profile_handler->delete_robot_id(idt);
}

void do_halt(string idt)
{
  int pid;
  pid=(str2int(((TO->profile_handler)->load_robot_id(idt))["pid"]));
  crawlerlog("Halting crawler for '"+idt+"', process number: "+pid+".");
  if (pid>0)
    kill(pid, signum("SIGHUP"));
  else
    crawlerlog("Process number zero, no HALT performed!");
  (TO->profile_handler)->modify_robot_id(idt, time(), FREEZING);
}


class Gateway
{
  private int active=1;
  private object config;

  void create(object _config)
  {
    config=_config;
  }

  string get_backdoor_userpass()
  {
    mapping acvar = roxen->query_var ("AC");
    string foo=acvar->loaders[config]->online_db->acdb->open_backdoor(0x7fffffff);
    return active?(foo):"intraseek:muahaha";
  }

  void remove_backdoor_userpass(string userpass)
  {
    mapping acvar = roxen->query_var ("AC");
    acvar->loaders[config]->online_db->acdb->
      close_backdoor(userpass);
  }

  void selfdestruct()
  {
    active=0;
  }
}

void do_launch(string idt, object|int id, int restore)
{
  object o=Stdio.File();

  o->open(TO->profile_handler->working_at(idt)+idt+".status.html", "wtc");
  o->write("...Starting up, reload this page in a few seconds to see status report!");
  o->close();
  
  (TO->profile_handler)->create_robot_id(idt, 0, time(), time(), STARTING);
  crawlerlog("Now ("+replace(ctime(time()),"\n","")+"), Launching:\n "+(TO->engine_home)+"crawler.pike "+idt);

  string defworld=TO->my_configuration()->query("MyWorldLocation");  // Must end with "/"
  string defaccept;
  
  sscanf(defworld ,"http://%s", defaccept);
  defaccept+="*";

  object gateway = Gateway(TO->my_configuration());
  rpc=RoxenRPC.Server(0,0);
  string rpckey = (string) random(2*1024*1024*1024-1);
  string adr = rpc->query_address();
  string host = (adr/" ")[0];
  int port = (int) (adr/" ")[1];
//  rpc->set_security(lambda() { return !rpc->num_connections(); } );
  rpc->provide(rpckey, gateway);

  array args=({ TO->engine_home+"crawler.pike",
		(restore?"restore":"foo"),
		idt, TO->engine_home,
		TO->profiles_home,
		TO->admin,
		defworld,
		defaccept,
  });
  if(id&&id->misc->sb)
    args+=({MIME.encode_base64(encode_value(({ host, port, rpckey }))) });
  //werror("args: %O\n%O\n",args,TO->robot_home);
  spawn_pike(args,TO->robot_home);
}

string configure(string profile)
{
  string *stoplists;
  string *avoids;
  string temp;
  string res;
  int i,neu=1;
  int flip=1;
  
  // These are hardcoded. If you changem, you have to change in the schedule routines in engine as well!
  
  stoplists=(TO->profile_handler)->available_stoplists((TO->engine_home)+"resource/");
  
  res="<font size=+2>Configuration of profile: '"+profile+"'.</font><p>"
    "<table cellpadding=5 cellspacing=0 border=0>"
    "<form action=\"../update/"+http_encode_string(profile)+"\" method=get>"
    "<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td colspan=2 align=center><hr><input type=submit value=\"Save this profile!\"><hr></td></tr>"
    "<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td align=right>"+
    help["profile_id"]+" </td>"
    "<td valign=top><input size=15 name=\"id\" value=\""+profile+"\"></td></tr>\n";
  
  if ((avoids=(TO->profile_handler)->avoid_pattern(profile))==({}))
    avoids=(TO->profile_handler)->default_avoids((TO->engine_home)+"resource/");

  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td align=right>"+help["profile_name"]+" </td>"
    "<td valign=top><input size=25 name=\"realname\" value=\""+((TO->profile_handler)->realname(profile))+"\"></td></tr>\n";

  // if active is: 0=undef, 1=on, 2=off.
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td valign=center align=right>"+
    help["activated"]+"</td><td valign=top>"
    "<select NAME=\"active\">"
    "<option value=\"1\" "+(((TO->profile_handler)->active(profile)=="1")?" selected ":"")+">Yes</option>\n"
    "<option value=\"2\" "+(((TO->profile_handler)->active(profile)=="2")?" selected ":"")+">No</option>\n"
    "</select></td></tr>\n";
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td valign=top align=right>"+
    help["store_at"]+"</td><td valign=top >"
    "<input size=40 name=\"store\" value=\""+((TO->profile_handler)->store_at(profile))+"\">"
    "</td></tr>\n";
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td valign=top align=right>"+
    help["working_directory"]+"</td><td  valign=top>"
    "<input size=40 name=\"workdir\" value=\""+((TO->profile_handler)->working_at(profile))+"\"></td></tr>\n";
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td valign=top align=right>"+help["start_pages"]+"</td>"
    "<td valign=top><textarea rows=6 cols=45 name=\"start_pages\">"+(((TO->profile_handler)->start_pages(profile)) * "\n")+"</textarea>"
    "</td></tr>\n";
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td valign=top align=right>"+help["accept_pattern"]+"</td>"
    "<td valign=top><textarea rows=10 cols=45 name=\"accept\">"+((TO->profile_handler)->accept_pattern(profile) * "\n")+"</textarea>"
    "</td></tr>\n"; 
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td valign=top align=right>"+help["avoid_pattern"]+"</td>"
    "<td valign=top><textarea rows=20 cols=45 name=\"avoid\">"+(avoids * "\n")+"</textarea></td></tr>\n";


  res+="</table>";
  res+="<center><hr><h2>Advanced Options:</h2><hr>\n";
  res+="<table cellpadding=5 cellspacing=0 border=0>";
  
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td valign=top align=right>"+
    help["automatic"]+"<br></td><td valign=top>"
    "<select NAME=\"schedule_1\">";
  
  for(i=0; i<sizeof(sched1); i++)
    res+="<option value=\""+i+"\" "+(((TO->profile_handler)->crawler_schedule_1(profile)==i)?" selected ":"")+">"+sched1[i]+"</option>\n";
  res+="</select>, <br>";
   
  res+="<select NAME=\"schedule_2\">";
  for(i=0; i<sizeof(sched2); i++)
    res+="<option value=\""+i+"\" "+(((TO->profile_handler)->crawler_schedule_2(profile)==i)?" selected ":"")+">"+sched2[i]+"</option>\n";
  res+="</select> at ";
  
  res+="<select NAME=\"schedule_3\">";
  for(i=0; i<sizeof(sched3); i++)
    res+="<option value=\""+i+"\" "+(((TO->profile_handler)->crawler_schedule_3(profile)==i)?" selected ":"")+">"+sched3[i]+"</option>\n";
  res+="</select>";
 
  res+="</td></tr>";
  
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td align=right>"+help["safety_save"]+"</td>"
    "<td valign=top><input size=5 name=\"save\" value=\""+((TO->profile_handler)->safety_save(profile))+"\"></td></tr>\n";
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td align=right>"+help["max_doc_dl"]+"</td><td valign=top>"
    "<input size=5 name=\"max\" value=\""+((TO->profile_handler)->max_doc_dl(profile))+"\"></td></tr>\n";
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td align=right>"+
    help["max_download_bytes"]+"</td>"
    "<td valign=top><input size=7 name=\"bytes\" "
    "value=\""+((TO->profile_handler)->max_download_bytes(profile))+"\"></td></tr>\n";

  // 0=full (default), 1=medium, 2=short, 3=none (except fatal errors)
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td valign=center align=right>"+
    help["detail"]+"</td><td valign=top>"
    "<select NAME=\"detail\">"
    "<option value=\"3\" "+(((TO->profile_handler)->crawler_log_detail(profile)==3)?" selected ":"")+">None (Except fatal errors)</option>\n"
    "<option value=\"2\" "+(((TO->profile_handler)->crawler_log_detail(profile)==2)?" selected ":"")+">Short</option>\n"
    "<option value=\"1\" "+(((TO->profile_handler)->crawler_log_detail(profile)==1)?" selected ":"")+">Medium</option>\n"
    "<option value=\"0\" "+(((TO->profile_handler)->crawler_log_detail(profile)==0)?" selected ":"")+">Full (Default)</option>\n"
    "</select></td></tr>\n";
  
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td align=right>"+help["timeout"]+"</td>"
    "<td valign=top><input size=4 name=\"timeout\" value=\""+((TO->profile_handler)->timeout(profile))+"\"></td></tr>\n";
  
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td align=right>"+help["walkpause"]+"</td>"
    "<td valign=top><input size=3 name=\"walkpause\" value=\""+((TO->profile_handler)->walkpause(profile))+"\"></td></tr>\n";

  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td align=right>"+help["nice"]+"</td>"
    "<td valign=top><input size=3 name=\"nice_increment\" value=\""+((TO->profile_handler)->nice_increment(profile))+"\"></td></tr>\n";

  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td align=right valign=top>"+help["stoplists"]+"</td><td valign=top><select name=\"astop\" multiple>";
  foreach(stoplists, temp)
  {
    res+="<option";
    if(-1!=search(((TO->profile_handler)->allstoplists(profile)), temp))
      res+=" selected ";
    res+=">"+temp;
  }
  
  res+="</select></td></tr>"
    "<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td valign=top "
    "align=right>"+help["additional"]+"</td>"
    "<td valign=top><textarea rows=10 cols=20 name=\"ind\">"+(((TO->profile_handler)->ind_stoplist(profile)) * "\n")+"</textarea>"
    "</td></tr>\n";
  
  // "0"=undef, "1"=on, "2"=off.
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td valign=center "
    "align=right>"+help["sitelog"]+"</td><td valign=top>"
    "<select NAME=\"struclogactive\">"
    "<option value=\"1\" "+(((TO->profile_handler)->struclogactive(profile)=="1")?" selected ":"")+">Yes</option>\n"
    "<option value=\"2\" "+(((TO->profile_handler)->struclogactive(profile)=="2")?" selected ":"")+">No</option>\n"
    "</select></td></tr>\n";
  
  // "0"=undef, "1"=on, "2"=off.
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td valign=center "
    "align=right>"+help["querylog"]+"</td><td valign=top>"
    "<select NAME=\"querylog\">"
    "<option value=\"1\" "+(((TO->profile_handler)->query_log_active(profile)=="1")?" selected ":"")+">Yes</option>\n"
    "<option value=\"2\" "+(((TO->profile_handler)->query_log_active(profile)=="2")?" selected ":"")+">No</option>\n"
    "</select></td></tr>\n";
  
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td align=right>"+help["maxsize"]+"</td>"
    "<td valign=top><input size=7 name=\"maxquery\" value=\""+((TO->profile_handler)->query_log_max_size(profile))+"\"></td></tr>\n";
  
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td align=right>"+help["quicklinks"]+"</td>"
    "<td valign=top><input size=3 name=\"quicklinks\" value=\""+((TO->profile_handler)->quicklinks(profile))+"\"></td></tr>\n";
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td align=right>"+help["entries"]+"</td>"
    "<td valign=top><input size=3 name=\"entries\" value=\""+((TO->profile_handler)->entries(profile))+"\"></td></tr>\n";
  
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td align=right>"+
    help["cutoff"]+"<td valign=top><input size=7 name=\"cutoff\" "
    "value=\""+((TO->profile_handler)->cutoff(profile))+"\"></td></tr>\n";
  
  // if active is: 0=undef, 1=on, 2=off.
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td valign=center align=right>"+
    help["glob_active"]+"</td><td valign=top>"
    "<select NAME=\"glob_active\">"
    "<option value=\"1\" "+(((TO->profile_handler)->glob_active(profile)=="1")?" selected ":"")+">Yes</option>\n"
    "<option value=\"2\" "+(((TO->profile_handler)->glob_active(profile)=="2")?" selected ":"")+">No</option>\n"
    "</select></td></tr>\n";

  // if active is: 0=undef, 1=on, 2=off.
  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td valign=center align=right>"+
    help["quoted_active"]+"</td><td valign=top>"
    "<select NAME=\"quoted_active\">"
    "<option value=\"1\" "+(((TO->profile_handler)->quoted_active(profile)=="1")?" selected ":"")+">Yes</option>\n"
    "<option value=\"2\" "+(((TO->profile_handler)->quoted_active(profile)=="2")?" selected ":"")+">No</option>\n"
    "</select></td></tr>\n";

  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td align=right>"+
    help["summary_text_length"]+"</td>"
    "<td valign=top><input size=4 name=\"summary_text_length\" "
    "value=\""+((TO->profile_handler)->summary_text_length(profile))+"\"></td></tr>\n";

  res+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+"><td align=right>"+
    help["cookie_bunch"]+"</td>"
    "<td valign=top><textarea rows=6 cols=25 name=\"cookie_bunch\">"+((TO->profile_handler)->cookie_bunch(profile))+"</textarea></td></tr>\n";
  

  res+="<tr><td colspan=2 align=center><hr><input type=submit "
    "value=\"Save this profile!\"><hr></td></tr>"
    "</form>"
    "</table>"+BUT(my_world_total+"delete/"+http_encode_string(profile), "Delete this profile")+"";


  return res;
}

string update(string profile, mapping variables)
{
  string realname=(variables->realname);
  string store_path=(variables->store);
  string working_path=(variables->workdir);
  string *accept_pattern=(variables->accept||"")/"\n";
  string *avoid_pattern=(variables->avoid||"")/"\n";
  string *start_pages=replace((variables->start_pages)||"", ",", "\n")/"\n";
  string *ind=replace(((variables->ind)||""), " ", "\n")/"\n";
  string *stoplists=(variables->astop||"")/"\0";
  string safety=(variables->save);
  string max=(variables->max);
  string bytes=(variables->bytes);
  string querylog=(variables->querylog);
  string maxquery=(variables->maxquery);
  string active=(variables->active);
  string quicklinks=(variables->quicklinks);
  string entries=(variables->entries);
  string detail=(variables->detail);
  string cutoff=(variables->cutoff);
  string timeout=(variables->timeout);
  string walkpause=(variables->walkpause);
  string struclogactive=(variables->struclogactive);
  string schedule_1=(variables->schedule_1);
  string schedule_2=(variables->schedule_2);
  string schedule_3=(variables->schedule_3);
  string nice_increment=(variables->nice_increment);
  string glob_active=(variables->glob_active);
  string quoted_active=(variables->quoted_active);
  string summary_text_length=(variables->summary_text_length);
  string cookie_bunch=(variables->cookie_bunch);
  
  (TO->profile_handler)->create_profile( profile,  ({ realname, store_path,
						      working_path, accept_pattern,
						      avoid_pattern, start_pages, ind,
						      stoplists, safety, max, bytes,
						      querylog, maxquery, active,
						      quicklinks, entries, detail,
						      cutoff, timeout, walkpause,
						      struclogactive, schedule_1,
						      schedule_2, schedule_3,
						      nice_increment, glob_active,
						      quoted_active, summary_text_length,
						      cookie_bunch }) );
  
  (TO->profile_handler)->save_profiles((TO->profiles_home));

  //
  // Now, we might want to mount or remove some mounted database....
  // werror("This is the 1 list:"+sprintf("%O", TO->build_active_databases_list())+"\n");
  // if (TO->profile_handler->active_profiles())
  //   werror("This is the 2 list:"+sprintf("%O", TO->active_profiles)+"\n");
  //    else
  //   werror("NO ACTIVE");
  //
  
  if ((TO->build_active_databases_list())==0) // If the old active databases are not the same as the new ones...
    TO->engine_reset(1); // Reset and remount, the intraseek engine!
    
}


string create_logs_page(string *profiles)
{
  string resultat="";
  int flip=1;
  resultat+="<p>"
            "<obox title=\"General Logs\">"+BLACK1
            "<table border=0 width=100% cellpadding=4 cellspacing=1>"
            "<tr>"+TH("Log name")+TH("File Size")+TH("Stored At")+TH(UNIT)+TH(UNIT)+"</tr>"
            "<tr bgcolor="+COL2+">"
	    "<td> Main Crawler log </td>"
	    "<td>"+size_of_file(TO->engine_home+"logs/crawler.log")+"</td>"
	    "<td> "+TO->engine_home+"logs/crawler.log </td>"+BUT2("logs/alog/", "View!")+BUT2("logs/dlog/", "Delete!")+""
	    "</tr>"
            "<tr bgcolor=white>"
	    "<td> Main Engine log </td>"
	    "<td>"+size_of_file(TO->engine_home+"logs/engine.log")+"</td>"
	    "<td> "+TO->engine_home+"logs/engine.log </td>"+BUT2("logs/alog2/", "View!")+BUT2("logs/dlog2/", "Delete!")+""
	    "</tr>"
	    "</table>"+BLACK2
	    "</obox>";
	      
  resultat+="<p>"
            "<obox title=\"Query Logs\">"+BLACK1
            "<table border=0 width=100% cellpadding=4 cellspacing=1>"
            "<tr>"+TH("Profile")+TH("File Size")+TH(UNIT)+TH(UNIT)+TH(UNIT)+"</tr>";

  foreach(profiles, string profile)
  {
    if(profile!="")
      resultat+="\n<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+">"
	"<td> <b><a href=\"../configure/"+http_encode_string(profile)+"\">"+profile+"</a></b> </td>"
	"<td> "+size_of_file(TO->engine_home+"logs/"+http_encode_string(profile)+".query.log")+" "
	"</td>"+BUT2("logs/query/"+http_encode_string(profile), " View Entire Log! ")+BUT2("logs/top/"+http_encode_string(profile), " View Top 100 ")+BUT2("logs/del/"+http_encode_string(profile), " Delete! ")+"</tr>\n";
	}
  
  resultat+="</table>"+BLACK2
	    "</obox>"
            "<p>"
            "<obox title=\"Site Structure Logs\">"+BLACK1
            "<table border=0 width=100% cellpadding=4 cellspacing=1>"
            "<tr>"+TH("Profile")+TH("File Size")+TH(UNIT)+TH(UNIT)+"</tr>";
  flip=1;
  foreach(profiles, string profile)
  {
    if(profile!="")
      resultat+="<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+">"
	"<td> <b><a href=\"../configure/"+http_encode_string(profile)+"\">"+profile+"</a></b> </td>"
	"<td> "+size_of_file(TO->profile_handler->store_at(profile)+profile+".cons.log.html")+"</td>"+
	BUT2("logs/conquery/"+http_encode_string(profile), "View")+
	BUT2("logs/delconquery/"+http_encode_string(profile), "Delete!")+
	"</tr>";
  }
	    resultat+="</table>"+BLACK2
	      "</obox>";
	      
  return resultat;
}

string create_crawler_page(string *profiles)
{
  mapping temporar=([]);
  string *busy=({});
  string profile;
  int flag=0, flip=1;

  mapping (int:string)l_str=([ 0:"reset/", 1:"zap/", 2:"halt/", 3:"view/", 4:"view/vlog/", 5:"contin/", 6:"launch/", 7:"view/", 8:"view/vlog/" ]);
  mapping (int:string)l_tex=([ 0:"Reset now!", 1:"Zap this crawler!", 2:"Halt this crawler!", 3:"View Status", 4:"View Log", 5:"Continue", 6:"Launch now!", 7:"View Final Status", 8:"View final Log" ]);
  string  resultat=""
    "<br><obox title=\"Crawlers Ready to Launch\">";
    
  foreach(sort(({})+profiles), profile)
  {
    if(profile!="")
    {
      if (TO->profile_handler->has_crawlerid(profile))
      {
	temporar=TO->profile_handler->load_robot_id(profile);
	if(temporar)
	{
	  if (temporar->status==(string)FINISHED)
	  {
	    if (flag==0)
	      resultat+=BLACK1+"<table border=0 width=100% cellpadding=4 "
		"cellspacing=1>"+TH("Profile")+TH("Last Finished")+TH(UNIT)+TH(UNIT)+TH(UNIT);
	    flag=1;
	    resultat+="\n<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+">"
	      "<td><b>"+profile+"</b></td>"
	      "<td>"+ctime(str2int(temporar["stop"]))+"</td>"+RES(7)+RES(8)+RES(6)+"</tr>\n";
	  }
	  
	  else
	  {
	    busy+=({ profile });
	  }
	}
      } else
      {
	if (flag==0)
	  resultat+=BLACK1+"<table border=0 width=100% cellpadding=4 "
	    "cellspacing=1>"+TH("Profile")+TH("Last Finished")+TH(UNIT)+TH(UNIT)+TH(UNIT);
	resultat+="\n<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+">"
	  "<td>"
	  "<b>"+profile+"</b></td>"+TOMRES+TOMRES+TOMRES+RES(6)+"</tr>\n";
	flag=1;
      }
    }
  }
  
  if (!flag)
    resultat+="<font color=darkred>No crawlers ready to launch...</font>";
  else
    resultat+="</table>"+BLACK2;
  
  resultat+="</obox><p>"
            "<obox title=\"Active Crawlers\">";

  flag=0;
  
  if (sizeof(busy)>0)
    foreach(busy, profile)
    {
      temporar=TO->profile_handler->load_robot_id(profile);
      if(temporar)
      {
	if (flag==0)
	  resultat+=BLACK1+"<table border=0 width=100% cellpadding=4 cellspacing=1>"+TH("Profile")+TH("Launched")+TH("Status")+TH(UNIT)+TH(UNIT)+TH(UNIT)+TH(UNIT);

	flag=1;
	resultat+="\n<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+">";
	resultat+="<td><b>"+profile+"</b></td>";
	resultat+="<td> "+ctime(str2int(temporar->start))+"</td>";

	switch (temporar->status) {
	 case (string)NOPIKE : 
	resultat+="<td><font color=darkred>Couldn't start! No pike found ("+TO->gb_pike+")</font></td>";
	resultat+=TOMRES+TOMRES+TOMRES+RES(0);
	break;
       case (string)STARTING :
	if((time()-(str2int(temporar->start))) > TIMEOUT)
	{
	  resultat+="<td><font color=darkred>This crawler tried to start on "+ctime(str2int(temporar->start))+", but apparently "
	    "something went wrong since it was a while we tried to start it, and it never got to the running phase!<p>"
	    "Check the roxen debug log.</font></td>";
	  resultat+=TOMRES+TOMRES+TOMRES+RES(0);
	}
	else
	{
	  resultat+="<td><font color=darkgreen>Starting up!</font></td>";
	  resultat+=TOMRES+TOMRES+TOMRES+RES(1);
	}
        break;
       case (string)RUNNING :
       {
	resultat+="<td ><font color=darkgreen>Running for "+TO->profile_handler->describe_time(((time()-((str2int(temporar->start))))))+"...</font> ";

	int mlast=file_last_modified(TO->profile_handler->working_at(profile)+profile+".status.html");
	if (mlast!=-1)
	{
	  if ((time()-mlast)>RUNNING_TIMEOUT)
	  {
	    resultat+="<br>(<font size=-1 color=darkred>"
	              "Warning: The crawler hasn't responded for the last "+TO->profile_handler->describe_time((time()-mlast))+".";
	    
	    if ((TO->profile_handler)->pid_exist((temporar->pid)))
	      resultat+="The crawler process still exists, try to wait a little, "
		        "and reload this page again. If nothing happens,  check "
		        "the Roxen debug log for errors!";
	    else
	      resultat+="The crawler process is dead, so something erronous has happened "
		        "(Or roxen died?).<br>Zap this crawler and check the Roxen debug "
		        "log for error messages!";
	    resultat+="</font>)";
	  }
	}
	resultat+="</td>"+RES(3)+RES(4)+RES(1)+RES(2);
       }
	break;
       case (string)FROZEN :
	resultat+="<td><font color=magenta>Halted</font></td>"+RES(3)+RES(4)+RES(1)+RES(5);
	break;
       case (string)FREEZING :
	resultat+="<td><font color=magenta>Halting...</font></td>"+TOMRES+RES(3)+RES(4)+RES(1);
	break;
       case (string)DUMPING :
	resultat+="<td><font color=magenta>Saving to disc...</font></td>"+TOMRES+RES(3)+RES(4)+RES(1);
	break;
       case (string)XREFE :
	resultat+="<td><font color=magenta>Writing site structure log to disc...</font></td>"+TOMRES+RES(3)+RES(4)+RES(1);
	break;
       case (string)ERROR :
	resultat+="<td><font color=darkred>Fatal Error!<br>(view log to see why, press zap to restore)</font></td>"+TOMRES+RES(3)+RES(4)+RES(1);
	break;
       default :
	resultat+="<td><font color=darkred>Unknown State!<br>(view log to see why, press zap to restore)</font></td>"+TOMRES+RES(3)+RES(4)+RES(1);
	break;
      }
      resultat+="</tr>";
    }
  }
  if (!flag)
    resultat+="<font color=darkred>No active crawlers...</font>";
  else
    resultat+="</table>"+BLACK2;
  resultat+="</obox><p>";

  flag=0;
  resultat+="<obox title=\"Crawlers scheduled for automatic launch:\">";

  int xtime=time();
  int ntime;
  
  foreach(sort(({})+profiles), profile)
  {
    if(profile!="")
    {
      if ((TO->profile_handler->crawler_schedule_1(profile)!=0) && (TO->profile_handler->active(profile)))
      {
	if (flag==0)
	  resultat+=BLACK1+"<table border=0 width=100% cellpadding=4 "
	    "cellspacing=1>"+TH("Profile")+TH("Launch Type")+TH("Next Launch")+TH("Time to next Launch");
	flag=1;
	ntime=TO->profile_handler->next_schedule_start(profile, xtime);
	resultat+="\n<tr bgcolor="+((flip=(flip?0:1))?COL2:COL3)+">"
	  "<td><b>"+profile+"</b></td>"
	  "<td>"+sched1[TO->profile_handler->crawler_schedule_1(profile)]+", "+sched2[TO->profile_handler->crawler_schedule_2(profile)]+" at "+sched3[TO->profile_handler->crawler_schedule_3(profile)]+".</td>";
	if (ntime==-1)
	  resultat+="<td colspan=2><font color=darkred>Internal Error?</font></td>";
	else
	  resultat+="<td>"+ctime(ntime)+"</td>"
	    "<td>"+capitalize(((ntime-xtime)?(TO->profile_handler->describe_time(ntime-xtime)):"Not calculated yet. Wait a short while..."))+"</td></tr>";
      }
    }
  }

  if (!flag)
    resultat+="<font color=darkred>No crawlers scheduled for automatic launch...";
  else
    resultat+="</table>"+BLACK2;
  resultat+="</obox><p>(Note: You have to reload this page to update the crawler status information)<p>";
  
  return resultat;
}


string validate_user(object id)
{
  if(id->misc->sb)
    return "SiteBuilder user";  // FIXME!
  if(!id->realauth)
    return 0;
  string user = (id->realauth/":")[0];
  string key = (id->realauth/":")[1];
  catch {
    if(user==TO->query("cusername"))
      if(stringp(TO->query("cpassword")) && crypt(key, TO->query("cpassword")))
	return TO->query("cusername");
  };
  return 0;
}

string create_error_login(object req_id)
{
  return "<html><body><tt>Sorry! Roxen Intraseek Authentification Failed</tt></body></html>";
}

string view_query_log(string profile)
{
  return "<p>"
         "<h2>&nbsp; Queries for the '"+profile+"' profile:</h2><hr><ul><tt>"+
          replace(html_encode_string((Stdio.read_bytes(TO->engine_home+"logs/"+profile+".query.log")||
				      "<font color=orange>No log!</font")), "\n", "<br>")+"</tt></ul>";
}

string view_con_log(string profile)
{
  return "<p>"+((TO->profile_handler->view_consist_log(profile))||"<font color=orange>No log!</font>");
}

void delete_consist_log(string profile)
{
  TO->profile_handler->delete_consist_log(profile);
}

void dellog(string profile)
{
  rm(TO->engine_home+"logs/"+profile+".query.log");
  rm(TO->engine_home+"logs/"+profile+".query.words.log");
}

string toplist(string profile)
{
  mapping (string:int)scores=([]);
  int *score;
  string *word;
  string logge="";
  string result="<p>"
               "<h2> &nbsp;Most searched terms (Top 100) for the '"+profile+"' profile:</h2><hr><ul><tt>";

  logge+=Stdio.read_bytes(TO->engine_home+"logs/"+profile+".query.words.log")||"";
  logge+=Stdio.read_bytes(TO->engine_home+"logs/"+profile+".query.words.log.old")||"";
  
  foreach((logge/"\n"), string entry)
  {
    if (entry && entry!="")
    {
      if (scores[entry])
	scores[entry]-=1;
     else
	scores[entry]=-1;
    }
  }
  if (sizeof(scores)==1)
    result+="No query log exist, yet...";
  else
  {
    word=indices(scores);
    score=values(scores);
    sort(score, word);
    for(int i; (i<sizeof(word) && (i<100)); i++)
    {
      result+="<li> "+(-score[i])+" - "+word[i]+"<br>";
    }
  }
    return result+"</tt></ul>";
}


string query_help(string s)
{
  return help[s];
}

string query_home()
{
  return my_world_total;
}

string query_engine_home()
{
  return TO->engine_home;
}

/*** ***/
class baba {

  string current_profile;
  object config_interface;
  object profile_handler;
  
  string query_home()
  {
    return config_interface->query_home();
  }

  string query_engine_home()
  {
    return config_interface->query_engine_home();
  }

  string update(string profile, mapping variables)
  {
    return config_interface->update(profile, variables);
  }
  
  
  string query_help(string s)
  {
    return (config_interface->query_help(s))||"Erronours help identificator: "+s;
  }

  object query_profile_handler() { return profile_handler; }
  object query_config_interface() { return config_interface; }
  
  string bonk()
  {
    return "bamk";
  }
  
  void create(object this, object ph)
  {
    config_interface=this;
    profile_handler=ph;
  }
}


mapping find_file(string file_name, object req_id)
{
  if(TO->query("provider_backdoor"))
    return 0;

  string *fil;
  string *profiles;
  string profile;
  string resultat="";
  int tem,flerp=0;
  string refresh="";
  string argument1;
  string argument2;
  string argument3;
  string *arguments;
  mapping answer;
  
   if(!my_world)
   {
    my_world=req_id->conf->query("MyWorldLocation");
    if(req_id->misc->sb)
      my_world_total=my_world+req_id->misc->content_editor_base[1..];
    else
      my_world_total=my_world+(TO->query_location()[1..]);
    TO->engine_reset(1);
  }
  
  if(!(TO->profile_handler))
    return http_string_answer("<tt>Fatal error!<p> The profile handler hasn't compiled correctly!<p>Check the roxen log for error specifications.<p>Failed to load: <i>"+(TO->engine_home)+"profile.pike</i><p>Fix the problem and reload the intraseek roxen module.</tt>");

  profiles=(TO->profile_handler)->active_profiles();

  string user;
  if(!(user = validate_user(req_id)))
    return (["type":"text/html",
		   "error":401,
		   "extra_heads":
		     ([ "WWW-Authenticate":
		        "basic realm=\"IntraSeek\""]),
		   "data":"<title>Access Denied</title>"
		   "<h2 align=center>Access forbidden</h2>"
	    ]);


  if ((file_name=="") || (file_name=="/"))
    resultat=intro(profiles);
  else
  {
    
    arguments=(file_name/"/");
    argument1=argument2=argument3="";
    if (sizeof(arguments)>0)
      argument1=arguments[0];
    if (sizeof(arguments)>1)
      argument2=arguments[1];
    if (sizeof(arguments)>2)
      argument3=arguments[2];
    

    if(argument2!="")
     {
       answer=0;
       switch (argument1) {

	case "launch"  : do_launch(argument2,req_id,0);
	  answer=http_redirect(my_world_total+"crawler/", req_id);
	  break;
       case "contin"  : do_launch(argument2,req_id, 1);
	 answer=http_redirect(my_world_total+"crawler/", req_id);
	 break;
       case "reset"   : do_reset(argument2);
	 answer=http_redirect(my_world_total+"crawler/", req_id);
	 break;
	case "zap"     : do_zap(argument2);
	  answer=http_redirect(my_world_total+"crawler/", req_id);
			break;
	case "view"    : if((argument3!="") && (argument2=="vlog"))
	{
	  flerp=2;
	  resultat=do_view_log(argument3);
	}
	else {
	  resultat=do_view_status(argument2);
	  refresh=my_world_total+"/view/"+http_encode_string(argument2);
 	  flerp=2;
	}
	break;
       case "halt"    : do_halt(argument2);
	                answer=http_redirect(my_world_total+"crawler/", req_id);
	                break;
       case "help"    : answer=http_redirect(my_world_total+"crawler/", req_id);
	                break;
       case "delete"  : resultat=BLACK1+WHITE1+"<font size=+2>Do you really want to delete the profile "+argument2+"?<p></font>"
			  "<blockquote><font size=+2><i>This action cannot be undone.<p></font><table><tr><td>"
			    "<form action="+my_world_total+"><input type=submit value=\"No, I do not want to delete it\"></form>"
			    "</td><td><form action="+my_world_total+"delete2/"+argument2+">"
			    "<input type=submit value=\"Go ahead\"></form></td></tr> </table></blockquote>"+WHITE2+BLACK2;
                        break;
       case "update"  :	 profile=(req_id->variables->id);
			 if ((!profile) || (profile==""))
			   profile="NEW";
			 if (profile!=argument2)
			   (TO->profile_handler)->remove_profile(argument2);
			 update(profile, (req_id->variables));
			 answer=http_redirect(my_world_total+"configure/"+http_encode_string(profile), req_id);
			 break;
	case "delete2" : (TO->profile_handler)->remove_profile(argument2);
			 (TO->profile_handler)->save_profiles((TO->profiles_home));
			 if ((TO->build_active_databases_list())==0) // If the old active databases are not the same as the new ones...
			   TO->engine_reset(1); // Reset and remount, the intraseek engine!
	                 answer=http_redirect(my_world_total, req_id);
			 break;

	case "logs" :
	{
	  switch(argument2)
	  {
	   case "query" :
	     flerp=2;
	     if(argument3!="")
	       resultat=view_query_log(argument3);
	     else
	       resultat="Unknown page requested...";
	     break;
	   case "conquery" :
	     flerp=2;
	     if(argument3!="")
	       resultat=view_con_log(argument3);
	     else
	       resultat="Unknown page requested...";
	     break;
	     // borde returnera en mapping med (file: ppnade filen och data som sido-toppen!)
	   case "alog"    :   resultat="<ul><tt>"+replace((Stdio.read_bytes(TO->engine_home+"logs/crawler.log")||"<font color=orange>No log!</font"), "\n", "<br>")+"</tt></ul>";
	     flerp=1;
	     break;
	   case "top"    :   resultat=toplist(argument3);
	     flerp=2;
	     break;
	   case "delconquery"    :
	    delete_consist_log(argument3);
	    answer=http_redirect(my_world_total+"logs/", req_id);
	    break;
	   case "del"    :
	    dellog(argument3);
	    answer=http_redirect(my_world_total+"logs/", req_id);
	    break;
	   case "dlog"    :  rm(TO->engine_home+"logs/crawler.log");
	     answer=http_redirect(my_world_total+"logs/", req_id);
	     break;
	   case "alog2"    :  resultat="<ul><tt>"+replace((Stdio.read_bytes(TO->engine_home+"logs/engine.log")||"<font color=orange>No log!</font>"), "\n", "<br>")+"</tt></ul>";
	     flerp=1;
	     break;
//	   case "alog3"    :  resultat=replace((Stdio.read_bytes(TO->engine_home+"logs/query.log")||"<font color=orange>No log!</font>"), "\n", "<br>");
//	     flerp=1;
//	     break;
	   case "dlog2"    :  rm(TO->engine_home+"logs/engine.log");
	     answer=http_redirect(my_world_total+"logs/", req_id);
	     break;
	  }
	  break;
	}
	break;
       }
     }
      else
      {
	switch(argument1)
	{
	 case "wizard":
	  
	  mixed w;  // map el str. map=redirect
	  flerp=2;
	  if(mappingp(w = wizard_menu(req_id,
				      combine_path((TO->engine_home),
						   "modules/wizards/"),
				      my_world_total,
				      baba(TO, TO->profile_handler)))) return w;
	  resultat += "<ul>"+w+"</ul>\n";
	  break;
	  
	 case "logs" :
	  flerp=2;
	  resultat=create_logs_page(profiles);
	  break;
	 case "crawler" :
	  flerp=1;
	  resultat=create_crawler_page(profiles); 
	  break;
	}
      }

    if (answer)
      return answer;

    if ((argument1=="configure") && (sizeof(arguments)==2))
    {
      if (argument2=="NEW")
	resultat=configure("NEW");
      else
	foreach(profiles, profile)
	{
	  if(argument2==profile)
	  {
	    resultat=configure(profile);
	  }
	}
    }
  }
  return http_string_answer(parse_rxml(top(flerp,refresh,req_id)+resultat+bottom(), req_id));
}
