#!NO

//
// Shared help
// Some of these strings also appear in the maunal.
//

#define INTRASEEK_VERSION "Roxen IntraSeek 1.0 beta 1"

mapping help=([ "profile_id" : "The <b><i>profile id</i></b> is a unique identification for the profile. "
	      "It should be a short identifying text, and must not contain any "
	      "spaces. For example, the id could be: <tt>my_profile</tt>.<p>",
			     
	      "profile_name" : "The contents of <b><i>Profile name</i></b> will be "
	      "seen on the selection tab on the search page shown to the outside "
	      "world. For example, this could be \"My test search\".",

	      "store_at" : "<b><i>Storage directory</i></b> is a search path in your file system. "
	      "End with a '/'. Intraseek has automatically created a special directory for storage"
	      "of the databases, but you can change this to any path in the file-system. "
	      "For example, this could be: <tt>/usr/www/intraseek/database</tt>",

	      "working_directory" : "<b><i>Working directory </i></b> is also a search path in your file "
	      "system. End with a '/'. This is where data from the crawlers' data gatherings will be "
	      "stored. Due to nature of the data base's workings, it is advantageous "
	      "for this to be situated on a local disk (i e one not accessed through " 
	      "NFS). This will increase the speed of the process by several hundred "
	      "per cent. For example: <tt>/tmp/</tt> or a similar locally-mounted disk may be used.",

	      "start_pages" : "<b><i>Startpages</i></b> is where you specify a set of pages for the crawler "
	      "to start at. It is usually sufficient to state the URL of the main page "
	      "of the site you are about to index, since an IntraSeek crawler will follow "
	      "all links it finds. Separate the various URLs by putting them on separate lines."
	      "For example: <tt>http://my.server.com/~sysadm/</tt>",

	      "accept_pattern" : "<b><i>Accept pattern</i></b> specifies which pages are to be accepted by the "
	      "crawler. There are two very "
	      "important things to consider here: <ol>"
	      "<li>Always limit the crawler to stay within your site. If you don't, "
	      "it will, without any warning, crawl out on the worldwide web.</li>"
	      "<li>Since the accept and avoid patterns "
	      "really are regexps, they should read \"<tt>^http://www.foo.com/*</tt>\""
	      " instead of \"<tt>www.foo.com/*</tt>\" if you want to make sure not to "
	      "index \"<tt>http://gazonk.www.foo.com/</tt>\".</li>"
	      "</ul>"	      
	      "Separate the various accept patterns by putting them on separate lines. "
	      "For example, this could be \"<tt>my.server.com/~webmaster/*</tt>\"",

	      "avoid_pattern" : "<b><i>Avoid pattern</i></b> specifies what sort of pages the crawler should avoid. "
	      "Already specified are file types that contain information the "
	      "crawler shouldn't index (eg source-files and the like). If "
	      "inappropriate, these may be removed in order to have the crawler "
	      "include these files."
	      "<p>"
	      "For example, If you specify \"<tt>*/~webmaster/non-public/</tt>\" here, "
	      "the crawler will avoid <tt>~webmaster/non-public/</tt> on all servers. "
	      "If you specify \"<tt>*my.server.com/~root/*</tt>\", \"<tt>/~root/</tt>\" will not "
	      "be indexed on the server <tt>my.server.com.</tt><p>"
	      "<p>"
	      "Remember to check arguments to CGI scripts and the like. For instance, "
	      "directory listings can sometimes enter infinite loops. If any such are "
	      "present, it is recommended that \"<tt>*?*</tt>\" be added here."
	      "<p>"
	      "Check up on the robot while it is running (check the log etc), so that it "
	      "doesn't go into a loop, run amok, etc.<p>",

	      "describe_profile" :           "<b><i>A profile</i></b> is a defined part of one or several web servers that should be indexed (ie made searchable)."
	      "For example, you can create a profile for the product information pages of you webserver, and another"
	      "for your employee homepages.",

	      "activated" : "An <b><i>activated</i></b>  profile is 'active' the intraseek "
	      "engine will try to mount the database at startup, and it will also be "
	      "scheduled for automatic crawler launches.",

	      "automatic" : "The <b><i>Automated update of the databases</i></b> setting "
	      "defines at which "
	      "intervals the databases should be automatically updated.<br> "
	      "If you want the crawler for a profile to be automatically launched at "
	      "certain intervals to keep the index databases up-to-date, you can use "
	      "this function. The selections should be pretty selfexplanatory. If you "
	      "select <i>Never!</i> at the first selection, the two following (<i>days</i> and  "
	      "<i>time</i>) will be ignored and crawlers will not be automatically launched. "
	      "For more status reports on scheduled crawlers, look at the logs page (in "
	      "the Intraseek configuration interface).",
	      
	      "safety_save" : "<b><i>Safety save</i></b> is the interval between the crawlers' "
	      "automatic saves to, and reorganizing of, the databases. 500 (making it save once every 500 pages) is "
	      "a reasonable value. (If you want further technical details on this function, check "
	      "chapter '9.3 - IntraSeek and memory usage.' in the manual).",
	      
	      "max_doc_dl" : "<b><i>Max documents to download</b></i> specifies the maximum number of pages "
	      "the crawler should index. It is a good idea to specify a maximum here. In case "
	      "something should go wrong, you avoid having the entire partition "
	      "filled by a huge database. Going wrong is usually equivalent with the robot "
	      "getting lost on the Internet (because of erronously written accept- and avoid "
	      "patterns. ",

	      "max_download_bytes" : "<b><i>Max download per document</i></b> defines, in "
	      "characters, how much of a document that should be downloaded. This is "
	      "used to limit index size.<br>"
	      "Normally, if you download the 100000 first characters of a "
	      "document, it is very likely that there are enough terms to cover the "
	      "content of the document. This will of course vary depending on the "
	      "type of information present on your site. If all words are important "
	      "(even those at the end of large documents) you should increase this "
	      "value to higher values (for instance, 999999). ",

	      "detail" :
	      "<b><i>Crawler log detail level </i></b>selects how much information that "
	      "the crawler "
	      "should write in the log.",

	      
	      "timeout" : "<b><i>Crawler page fetch Timeout</b></i> defines how "
	      "many seconds that should pass before the "
	      "download of a page will be aborted. For example, if a crawler "
	      "can connect to a page, but doesnt get anything from the web server in "
	      "the other end, it will patiently wait for information - forever, if it "
	      "hadn't been for this setting. Enter how many seconds you allow the "
	      "fetcher to do its work.",

	      "walkpause" : "The robot is quite fast. If you index pages outside your "
	      "own net, you "
	      "should slow it down somewhat by changing the <i><b>Crawler walk "
	      "pause</i></b> between "
	      "each document download,"
	      "which is the number of seconds the robot should pause "
	      "before fetching the next document. This keeps it from causing large "
	      "loads on the web servers of others. ",
	      
	      "nice" : "<b><i>Crawler nice increment</i></b> sets the 'nice level' of "
	      "the crawler. If you are not familiar with UNIX, the UNIX-command "
	      "<tt>man nice</tt> will explain "
	      "things further. As a short summary, the nice increment level defines how nice "
	      "the process should be with usage of system resources. A crawler with a "
	      "high nice value will galdly give away processor time to other "
	      "processes if they are in need. The level is zero by default, and the "
	      "maximum level is 19. If the web server runs as root, it is possible to "
	      "make the process more 'mean' by setting nice increment as far down as "
	      "-19.",

	      "stoplists" : "<b><i>Stop lists</i></b> specifies which lists of short, common "
	      "words that should <i>not</i> be indexed, e g 'and' or 'again'. Here, several stop "
	      "lists are specified. Select one or more (or none) depending on which languages "
	      "are used on your server's pages. The stop lists are stored as ordinary "
	      "text files in the directory '</tt>ENGINE_HOME/resource/</tt>'.<br> ",

	      "additional" : "<i><b>Additional stop words</i></b> indicates extra stop "
	      "words that should be filtered. If 'Yoyodyne Productions' is present on "
	      "every one of your pages, it may be a good idea to specify 'yoyodyne' and "
	      "'productions' here. The disadvantage is that it will not then be possible "
	      "to search for the words 'yoyodyne' or 'productions', the advantage is "
	      "that the database files will be smaller, and searches faster.",
	      
	      "sitelog" : "<b><i>Site structure logging</i></b> of web site errors and warnings."
	      "If active, site structure logs will be generated for this profile. "
	      "See the logs chapter for information on site structure logs. If you "
	      "are not interested in the site structure log, you can turn it off "
	      "here and save crawler time consumption, space on disc and memory (You "
	      "will benefit from less memory usage by the crawler, and no "
	      "logs that take place on disc. Also, the operations that control the log will "
	      "be disabled.)",

	      "querylog" : "<b><i>Query Logs active</i></b>. "
	      "If <i>'yes'</i>, queries will be logged to disc, for top 100 statistics, and such.",

	      "maxsize" : "<b><i>Max size of query logs</i></b> is specified in bytes. "
	      "When a query log exceeds this size, it will be moved to a .bak file. "
	      "The old .bak file will be removed. ",


	      "quicklinks" : "<b><i>Number of max quick links displayed</b></i>. "
	      "If you have a search resulting in several hundred pages, a list of several "
	      "links to the next pages of result will be displayed below the list of summaries. "
	      "The 'quick links' referred to here, are the "
	      "maximum number of links to show.",

	      "entries" : "<b><i>Number of documents summaries</i></b> defines how many "
	      "search summaries to display at every page.",

	      "cutoff" :
	      "<b>Cutoff evaluation</b></i>.  Explained with an example: Let's "
	      "say you have a site with 12000 pages, all containing the word "
	      "'service'. When a user searches for 'service', Intraseek looks up "
	      "the word in its index and find relevant pages. Then it calculates a "
	      "score for each page, and finally sort it. A rather time-consuming "
	      "process. The user is probably not interested in 12000 documents "
	      "about this word, and calculating scores for this many is useless. Thats "
	      "why there is a cutoff available. In our example, there would most likely "
	      "have been good search results even if we just calculated scores for "
	      "some 2000 documents. ",

	      "summary_text_length" : "<b><i>Summary text length</i></b> is the length (in characters) "
	      "of the summaries displayed along with the search results and the "
	      "link and the hit percent. If used on the webpage, the Meta description will "
	      "be used for this, otherwise the first part of the document becomes a summary. ",

	      "quoted_active" : "If the setting <b><i>Quoted search enabled</i></b> is set to <i>'yes'</i>, "
	      "the users of the search engine can use quotation marks to search for a phrase. "
	      "For example, a search for \"John Carl Smith\" will search for persons with this name. Without "
	      "quotes, the search would return any pages that use any of those common names.<br>"
	      "Note that an extra database will be used to store the extra information, if "
	      "this setting is enabled. <b>Note:</b> With the current implementation of full text searches we cannot "
	      "guarantee good performance for databases covering more than 1000 documents. If you have more "
	      "documents, turn this option off, or IntraSeek can sometimes get stuck with heavy calculations for "
	      "several seconds.", 

	      "glob_active" : "If the setting <b><i>Wildcards  "
	      "enabled</i></b> is set to <i>'yes'</i>, "
	      "the users of the search engine can use quotation marks (?) and "
	      "asterisks (*) to broaden searches. A search for <i>'net*'</i> might match "
	      "'netscape', 'nethack', 'network' and so on. A search for <i>'int??net </i> matches "
	      "'intranet' as well as 'internet'. Note that IntraSeek requires that the user "
	      "specifies at least three characters in front of the * notation, and that there is no "
	      "distinction made between lower- and uppercase searches.<br>"
	      "Also note that an extra database will be used to store the extra information, if "
	      "this setting is enabled.",
	      
	      "cookie_bunch" : "<b><i>Cookies for this profile</i></b>. Syntax is; cookie_name1=value1, cookie_name2=value2, cookie_name3=value3... and so on.",
	      
	      ]);
