//
// This source-code is a part of the Roxen IntraSeek search engine package.
//  1996-1998 Idonex AB
// Email: info@idonex.se
//

inherit "wizard";

constant name = "New Profile Wizard";
constant doc = "";

#define VAR id->variables

string page_0(object id, object o)
{
  return  "Welcome to the Intraseek Profile Wizard!<p>"
    "This wizard helps you to create a new 'profile'.<p>"+(o->query_help("describe_profile"))+"<p>Press next to get started!";
}

string page_1(object id, object o)
{
  return  "Select a profile identification:<p>"
    " <var type=string name=\"id\">"
    "<p>"+(o->query_help("profile_id"));
}

string page_2(object id, object o)
{
  return  "Select a profile name:<p>"
    " <var type=string name=\"realname\">"
    "<p>"+(o->query_help("profile_name"));
}

string page_3(object id, object o)
{
  return  "Select a storage directory:<p>"
    " <var type=string "
    "default="+((o->query_profile_handler())->store_at("NEW"))+" name=\"store\">"
    "<p>"+(o->query_help("store_at"));
}

string page_4(object id, object o)
{
  return  "Select a working directory:<p>"
    " <var type=string "
    "default="+((o->query_profile_handler())->working_at("NEW"))+" name=\"workdir\">"
    "<p>"+(o->query_help("working_directory"));
}

string page_5(object id, object o)
{
  return  "Enter one or several startpages:<p>"
    " <var type=text "
    "default=\""+(((o->query_profile_handler())->start_pages("NEW"))*"\n")+"\" "
    " name=\"start_pages\">"
    "<p>"+(o->query_help("start_pages"));
}

string page_6(object id, object o)
{
  
//  werror("===>"+sprintf("%O", id->variables->start_pages));
  
  array def = Array.map((id->variables->start_pages)/"\n",
	      lambda(string d){ sscanf(d,"http://%s", d); d=replace(d,"\r",""); return d+"*"; })-({"*"})-({});

  return  "Specify Acceptpattern:<p>"
    " <var type=text "
    "default=\""+((def)*"\n")+"\" name=\"accept\">"
    "<p>"+(o->query_help("accept_pattern"));
}

string page_7(object id, object o)
{
  string *avoids;
  
  if ((avoids=(o->query_profile_handler())->avoid_pattern("NEW"))==({}))
    avoids=(o->query_profile_handler())->default_avoids((o->query_engine_home())+"resource/");
  
  return  "Specify Avoidpattern:<p>"
    " <var type=text "
    "default=\""+(avoids*"\n")+"\" name=\"avoid\"> "
    "<p>"+(o->query_help("avoid_pattern"));
}

string page_8(object id, object o)
{
  string r = "";
  
  string *def_avoids=(o->query_profile_handler())->default_avoids((o->query_engine_home())+"resource/")-({})-({""})-({"\n"});
  string *my_avoids=((id->variables->avoid)/"\r\n")-({})-({""})-({"\n"});
  string *additional_avoids=my_avoids-def_avoids;
  string *removed_avoids=def_avoids-my_avoids;

  r += "Almost done!<p>You are about to create this profile:<p>"
    "<ul>"
    "<li> A profile with the id \"<b>"+id->variables->id+"</b>\" named \"<b>"+id->variables->realname+"</b>\"</li>\n"
    "<li> It will use the path \"<b><tt>"+id->variables->workdir+"</tt></b>\" for "
    "temporary storage, and \"<b><tt>"+id->variables->store+"</b></tt>\" for permanent.</li>\n"
    "<li> It will start at:<ul>";
  
  foreach (((id->variables->start_pages)/"\n")-({})-({""})-({"\n"}), string page) r+="<li>"+page+"</li>";
  
  r+="</ul></li>"
     "<li>It will accept all URLs that match: <ul>";

  foreach (((id->variables->accept)/"\n")-({})-({""})-({"\n"}), string page) r+="<li>"+page+"</li>";
  
  r+="</ul>";
  
  if (sizeof(additional_avoids))
  {
    r+="<li>You have added these avoids to the default pattern:<ul>";
    foreach (additional_avoids, string page) r+="<li>"+page+"</li>";
    r+="</ul>";
  }

  if (sizeof(removed_avoids))
  {
    r+="<li>You have removed these avoids from the default pattern:<ul>";
    foreach (removed_avoids, string page) r+="<li>"+page+"</li>";
    r+="</ul>";
  }
  return r;
}

mapping wizard_done(object id, object o)
{
  string profile=((id->variables)["id"]);
  if ((!profile) || (profile==""))
    profile="NEW_"+time();
  o->update(profile, (id->variables));
  return http_redirect(o->query_home(), id);
}
