// Roxen LogView Array Operation Functions
//
// Copyright (C) 1996, 1997 Informationsvvarna
//

array normalize(mixed m)
{
  if(mappingp(m))
    return values(m);
  return m;
}

mapping array_add(mapping m, mixed row, array(int) keys, array(int) sum_by)
{
  string key = encode_value(rows(row, keys));
  if(array(mixed) a = m[key])
    foreach(sum_by, int v)
      a[v] += row[v];
  else
    m[key] = copy_value(row);
  return m;
}

mapping array_acc(mixed m, mixed data, array(int) sum_by,
		  array(int)|void ignore, function|void add_f)
{
  if(!add_f) add_f = array_add;

  data = normalize(data);
  if(arrayp(m)) {
    data += m;
    m = ([]);
  }
  
  if(!sizeof(data))
    return m;
  
  array(int) keys=indices(data[0])-sum_by-(ignore||({}));
  foreach(data, array(mixed) row)
    add_f(m, row, keys, sum_by);
  return m;
}

array array_sum(array(array(mixed)) data, array(int) sum_by)
{
  return normalize(array_acc(([]), data, sum_by));
}

array(array(mixed)) array_sort(array(array(mixed)) data, int c)
{
  data = copy_value(data);
  sort(column(data, c), data);
  return data;
}
