//
//
//

#define Sql_ERR(msg) throw(({ "(ExportSQL) "+msg+"\n",backtrace() }))

class export_sql {
  object sql;

  string encode(mixed m)
  {
    return replace(encode_value(m),
		   ({ "\0", "\\", "'", "\"" }),
		   ({ "\\0", "\\\\", "\\'", "\\\"" }));
  }


  string escape(string s)
  {
    return replace((string)(s||"-"),
		   ({ "\0", "\\", "'", "\"" }), ({ "", "", "", "" }));
  }

  string nicefy(string s)
  {
    return replace(s, ({ " ", "(", ")", "/", "%" }),
		   ({ "_", "_", "_", "_per_", "percentage" }));
  }

  void export(string group, string funame, object pdb, object rpc)
  {
    string sql_table;
    catch {
      sql->query("create table logview_index("
		 "logview_id integer auto_increment primary key, "
		 "logview_group varchar(255) not null, "
		 "unique(logview_group))");
    };
    catch {
      sql->query("insert into logview_index(logview_group) "
		 "values('"+group+"')");
    };
    sql_table = sprintf("logview_%s",
			sql->query("select logview_id from "
				   "logview_index where "
				   "logview_group = '"+group+"'")
			[0]->logview_id);
    catch {
      sql->query("create table "+sql_table+"_update("
		 "logview_table varchar(127) not null primary key, "
		 "logview_update longblob not null)");
    };

    string table = funame, report = rpc->fu_title(table);
    if(report) {
      werror("  SQL fu: "+report+"\n");
      array db_index = ({});
      mapping db_i = pdb->table(table)->get("db_index") || ({});
      foreach(indices(db_i), array db_name)
	db_index |= Array.map(db_i[db_name], lambda(string s, string a)
					     { return s+"_"+a; }, db_name);
      array old = ({});
      catch(old = decode_value(sql->query("select logview_update from "+
					  sql_table+"_update where "
					  "logview_table = '"+table+"'")
			       [0]->logview_update));
      int year, month, day;
      mapping m = ([]);
      foreach(db_index - old, string s)
	if(sscanf(s, "%d_%d_%d", year, month, day) == 3)
	  m[sprintf("%04d_%02d_%02d", year, month, day)] = 1;
	
      int tc = 0;
      array fields = ({});
      string current = sql_table+"_"+table;
      foreach(sort(indices(m)), string entry) {
	sscanf(entry, "%d_%d_%d", year, month, day);
	mapping t = rpc->tag_logview("sql",
				     ([ "display":"sql",
					"group":group,
					"report":report,
					"unit":"day",
					"per":"day",
					"from-year":(string)year,
					"from-month":(string)month,
					"from-day":(string)day,
					"to-year":(string)year,
					"to-month":(string)month,
					"to-day":(string)day ]),
				     (["misc":
				       (["logview_portal":1])]));
	string date = sprintf("%04d-%02d-%02d", year, month, day);
	werror("    SQL upd: "+date+" ");
	if(mappingp(t)) {
	  if(!tc) {
	    for(int i=3;i<sizeof(t->types)&&i<sizeof(t->fields); i++) {
	      if(t->types[i] == "num")
		fields += ({ nicefy(t->fields[i][0..126])+
			     " integer not null" });
	      else
		fields += ({ nicefy(t->fields[i][0..126])+
			     " varchar(127) not null" });
	    }
	    if(catch(sql->query("select count(*) from "+current)))
	      sql->query("create table "+current+"("
			 "the_date date not null, "+fields*", "+")");
	    tc = 1;
	  }
	  sql->query("delete from "+current+" where the_date='"+date+"'");
	  foreach(t->table, array row)
	    sql->query("insert into "+current+" values("+
		       Array.map(({ date }) + row[3..],
		       lambda(string s, function f)
		       { return "'"+f(s)+"'"; }, escape)*", "+")");
	}
	werror("ok.\n");
      }
      if(catch(sql->query("insert into "+sql_table+"_update values("+
			  "'"+table+"', '"+encode(db_index)+"')")))
	sql->query("update "+sql_table+"_update set logview_update = "
		   "'"+encode(db_index)+"' where "
		   "logview_table = '"+table+"'");
    }
  }

  void create(object sql_in)
  {
    sql = sql_in;
  }
}
