// Roxen LogView Fu Class
//
// Copyright (C) 1996, 1997, 1998 Informationsvvarna
//

class fu {
  static private object rpc;
  static private string fu_dir;
  static private mapping cache = ([]);
  static private mapping mtime = ([]);

  static private function warning;

  /*
  ** Exception handling mechanism
  */

  void exception(function warning_in)
  {
    warning = warning_in;
  }

  static private int exception_counter = 0;
  static private mixed tex(mixed bt)
  {
    exception_counter++;
    if(warning && exception_counter < 10)
      if(stringp(bt))
	warning("(Fu)\n"+bt);
      else
	warning(bt);
    return bt;
  } 

  program compile_fu(string src, string filename)
  {
    array err;
    program p;
    master()->set_inhibit_compile_errors("");
    if(err = catch(p = compile_string(src, filename)))
      tex(master()->errors+"\n");
    master()->set_inhibit_compile_errors(0);
    return p;
  }

  object query_fu(mapping m, mapping|void args)
  {
    if(!m) return 0;
    program p;
    if(!(p = compile_fu(m->src, m->filename)))
      return 0;
    object fu = p();

    foreach(indices(args || ({})), string arg) {
      // werror(sprintf("arg = %O", arg));
      if(mkmultiset(indices(fu))[arg]) {
	// werror(sprintf(" ok."));
	string type;
	sscanf(arg, "%*s_%s_%*s", type);
	switch(type) {
	case "int":
	  sscanf(args[arg], "%d", fu[arg]);
	break;
	case "str":
	default:
	  fu[arg] = args[arg];
	}
      } 
      // werror(sprintf("\n"));
    }
    if(fu->start) fu->start();
    return fu;
  }
  
  mapping load_fu(string funame)
  {
    if(rpc) return rpc->load_fu(funame);
    
    int t;
    object o;
    program p;
    string src, filename = fu_dir+funame+".pike";

    if(!(t = (file_stat(filename) || ({ 0,0,0,0 }))[3]))
      return 0;
    if(t > mtime[funame]) {
      if(!(src = Stdio.read_bytes(filename)))
	return 0;
      if(!(p = compile_fu(src, filename)))
	return 0;
      
      object o = p();
      mapping m = ([]);

      m->src = src;
      m->filename = filename;
      
      string group, title;
      sscanf(o->title || filename, "%s//%s", group, title);
      if(!title) {
	title = (filename/"/")[-1] - ".pike";
	group = "99:Misc";
      }
      m->title = title;
      m->group = group;

      m->log_args = glob("log_*", indices(o));
      m->group_args = glob("group_*", indices(o));
      m->fetch = o->fetch?Array.map(o->fetch, lower_case):({});
      m->vues = o->vues;
      m->depend = o->depend;
      m->as_is = o->as_is;
      m->invisible = o->invisible;
      m->depend_type = o->depend_type || "fu";
      m->display_types = o->display_types?o->display_types:({ "table" });

      if(m->fetch)
	for(int i = 0; i < sizeof(m->fetch); i++)
	  m->fetch[i] = lower_case(m->fetch[i]);
      
      cache[funame] = m;
      mtime[funame] = t;
    }
    return copy_value(cache[funame]);
  }

  array(string) list_fus()
  {
    if(rpc) return rpc->list_fus();
    
    array a = ({});
    foreach(sort(Array.map(glob("*.pike", get_dir(fu_dir) || ({})),
	     lambda(string s) { return s-".pike"; })), string funame) {
      if(load_fu(funame))
	a += ({ funame });
    }
    return a;
  }

  array(string) list_log_args()
  {
    if(rpc) return rpc->list_log_args();
    array v = ({});
    foreach(list_fus(), string funame)
      v |= load_fu(funame)->log_args;
    return v;
  }
  
  array(string) list_group_args()
  {
    if(rpc) return rpc->list_group_args();
    array v = ({});
    foreach(list_fus(), string funame)
      v |= load_fu(funame)->group_args;
    return v;
  }
  
  void create(string fu_dir_in, object|void rpc_in)
  {
    rpc = rpc_in;
    fu_dir = combine_path(combine_path(getcwd(), fu_dir_in), "./");
  }
}
