// Roxen LogView Import Classes
//
// Copyright (C) 1996, 1997, 1998 Informationsvvarna
//

#define MAX_LOG_SIZE 10000

#define NUM_LOOKUPS 10

#if __VERSION__ >= 0.6
import ".";
import "../";
#endif

#if 0
  object host;

  int is_IP(string host)
  {
    return sscanf(host, "%*d.%*d.%*d.%*d") >= 3;
  }
  
  void IP_lookup(array row)
  {
    werror(sprintf("Lookup on %O\n", row[0]));
    int n = sizeof(cache);
    cache[n] = row;
    host->ip_to_host(row[0], got_name, n);
    catch(_do_call_outs());
  }

  mapping cache = ([]);
  void flush()
  {
    if(sizeof(cache))
      sleep(1);
    foreach(indices(cache), int n)
      bucket->add(cache[n]);
    cache = ([]);
  }

  void got_name(string host, int n)
  {
    bucket->add(cache[n], row);
    m_delete(cache, n);
  }

  // host = LogView.Host.host(NUM_LOOKUPS);
#endif

class import_clf {
import Array;
import Stdio;
import RmDir;
  
  object rpc, bucket;
  // object dman;
  
  int log_rows = 0;
  int nfields;
  mapping(string:int) field_map =
  ([ "host":1, "referrer":2, "authuser":3,
     "year":4, "month":5, "date":6, "hour":7, "minute":8,
     "second":9, "timezone":10, "method":11, "path":12,
     "protocol":13, "status":14, "size":15 ]);
  
  string db_name;
  string tablename;
  
  array(int) field_remap;
  array(string) f_name;
  array(mixed) row;
  
  array(int) log_date = ({ 0 });
  
  int start_time;
  
  int logfilesize, offset, override_mode;
  string dir, dbdir, logfilename, dbfilename, workingbucket;
  string offset_filename;

  string time_interval(int s)
  {
    return sprintf("%02d:%02d:%02d", s/3600,(s%3600)/60,s%60);
  }

  void save_offset()
  {
    object file = Stdio.File();
    if(file->open(offset_filename+".tmp", "wct")) {
      if(file->write(sprintf("%4c", offset)) == 4)
	mv(offset_filename+".tmp", offset_filename);
      file->close();
    }
  }

  void status()
  {
    int time_now = time();
    int delta = time_now-start_time;
    float r = (float)offset/(float)logfilesize;
    int left = (int) ((float)delta/r) - delta;
    werror(sprintf(" ok [%d, %d%%, %s left].\n",
		   offset, (int)(100*r), time_interval(left)));
  }
  
  void open_bucket(array(int)|void date)
  {
    if(!bucket) {
      if(!date && !catch(bucket = LogView.Bucket.bucket(workingbucket,"w"))) {
	int y, m, d, min, sec;
	int n = sscanf(bucket->name(), "%d_%d_%d:%d:%d", y,m,d,min,sec);
	log_date = ({ y,m,d });
	return;
      }
      if(!date) return;
      string tablename = sprintf("%04d_%02d_%02d", @date);
      bucket = Bucket.bucket(workingbucket, "w", tablename, f_name);
      bucket->purge_q();
      log_date = copy_value(date);
    }
  }
  
  void bundle()
  {
    if(!bucket)
      open_bucket();

    if(bucket) {
      save_offset();
      bucket->bundle(combine_path(dbdir, dbfilename+"/log"));
      bucket = 0;
      status();
      rpc->bonk();  // Check if Roxen is alive
    }
  }
  
  void add(array(mixed) fields, int offset_in) {
    offset = offset_in;
    if(!equal(log_date, fields[3..5]) || (log_rows++ > MAX_LOG_SIZE)) {
      // werror(sprintf(" [[[ %O <-> %O ]]] ", log_date, fields[3..5]));
      log_rows = 0;
      bundle();
      open_bucket(fields[3..5]);
      werror(sprintf("  working: %04d-%02d-%02d", @log_date));
    }
    foreach(indices(row), int i)
      row[i] = fields[field_remap[i]];
    bucket->add(row);
  }

  void create(string dir_in, string logfilename_in, string dbfilename_in,
	      object rpc_in, int|void override_mode_in)
  {
    rpc = rpc_in;
    dir = dir_in;
    logfilename = logfilename_in-"\n";
    dbfilename = dbfilename_in;
    override_mode = override_mode_in;
    f_name = ({ "host", "referrer", "authuser",
		"year", "month", "date",
		"hour", "minute", "second", "timezone",
		"method", "path", "protocol", "status",
		"size" });

    nfields = sizeof(f_name);
    row = allocate(nfields);
        
    field_remap = allocate(nfields);
    foreach(indices(f_name), int i) {
      int j = field_map[f_name[i]];
      if(!j) throw(({ "field name noexistant\n", backtrace() }));
      j--;
      
      field_remap[i] = j;
    }
    
    dbdir = combine_path(dir, "logs/");
    mkdir(dbdir);
    string logdir = combine_path(dbdir, dbfilename);
    mkdir(logdir);
    string workingdir = combine_path(logdir, "import");
    mkdir(workingdir);
    offset_filename = combine_path(workingdir, "offset");
    string s = read_bytes(offset_filename);
    if(s && sizeof(s) == 4)
      sscanf(s, "%4c", offset);
    else {
      werror("Unable to read previous offset. Offset reset.\n");
      offset = 0;
    }
    workingbucket = combine_path(workingdir, "working");

    array(int) a = file_stat(logfilename);
    if(!a) {
      rpc->error("(Summary) Common Log File <b>"+logfilename+"</b> does "
		 "not exist. Permissions problems? Please also check if "
		 "the path is correct. If not, change it in the "
		 "``Logs...''-menu in the LogView configuration interface.");
      werror("Common Log File "+logfilename+" does not exist.\n");
      return 0;
    }
    logfilesize = a[1];
    if(logfilesize < offset) {
      rpc->warning("(Summary) Common Log File <b>"+logfilename+"</b> "
		   "is smaller than before. File offset is reset.");
      werror("Common Log File "+logfilename+"\n"
	     "is smaller than before. File offset is reset.\n");
      offset = 0;
    }

    // dman = LogView.LogMan.log_man(dbdir, "w");
    // dman->select_db(dbfilename);

    start_time = time();
    offset = CommonLog.read(add, logfilename, offset);
    bundle();
	
    save_offset();
  }
}
