// LogView Report Functions.

mapping defaults(string name, string group)
/* Read and prepare predefined default report templates. */
{
  mapping reports = ([ "reports":([]),
		       "report_descriptions":([]) ]);
  string dir = combine_path(__FILE__,"../")+"report.templates";
  
  foreach(glob("*.report", get_dir(dir)||({})), string report) {
    string name, description, contents;
    array a = Stdio.read_bytes(combine_path(dir, report))/"#";

    name = a[1]-"\n";
    description = a[2];
    contents = replace(a[3], ({ "$name$", "$group$" }), ({ name, group }));
    
    reports->reports[name] = contents;
    reports->report_descriptions[name] = description;
  }
  
  return reports;
}
