// LogView function

inherit "fu.pik";

constant title = "1:Authentications//5:Authenticated hosts & users";
constant fetch = ({ "host", "authuser", "hits" });

constant fields = ({ "Host", "User", "Hits" });
constant types = ({ "text", "text", "num" });

mapping display(mapping args, array table)
{
  object t = LogView.Table.table(table, fields);
  t = t->rsort("Host")->rsort("Hits", "Pages");
  return ([ "fields":rows(mkmapping(fields, fields), indices(t)),
	    "types":rows(mkmapping(fields, types), indices(t)),
	    "table":values(t) ]);
}

array store(array table)
{
  return table;
}

array join(array t1, array t2)
{
  return values(LogView.Table.table(t1+t2, fields)->
		    sum("Hits")->rsort("Hits")->
		    truncate(group_int_Max_Table_Size));
}

array fu(array table)
{
  object t = LogView.Table.table(table, fetch);
  t = t->filter(lambda(string user) { return user; }, "authuser")->sum("hits");
  return values(t);
}
