// LogView function

inherit "fu.pik";

constant title = "0:Site activity//1:Bandwidth";
constant fetch = ({ "Hour", "Size" });
constant vues = ({ "day" });
constant display_types = ({ "line chart", "bar chart" });

mapping display(mapping opt, array table, int sum)
{
  array fields = ({ "Hour", "Bandwidth (bit/s)" });
  array types = ({ "text", "num" });
  int n = opt->ndays||1;
  for(int r = 0; r < sizeof(table); r++)
    table[r][1] /= n;
  if(sum)
    return ([ "fields":fields[1..], "types":types[1..],
	      "table":({ ({ `+(0.0, @column(table, 1))/24.0 }) }) ]);
  return ([ "fields":fields, "types":types, "table":table ]);
}

array store(mixed table)
{
  return array_sort(normalize(table), 0);
}

mapping join(mixed old_table, mixed new_table)
{
  return array_acc(old_table, new_table, ({ 1 }));
}

mapping fu(mixed data_in)
{
  array data = ({});
  foreach(data_in, array row)
    data += ({ ({ sprintf("%02d", row[0]), (float) row[1] * 8.0/3600.0 }) });
  for(int i = 0; i < 24; i++)
    data += ({ ({ sprintf("%02d", i), 0.0 }) });
  return join(([]), data);
}
