// LogView function

inherit "fu.pik";

string log_str_Page_Regexp;
int group_int_Max_Table_Size;

constant title = "0:Visitor origins//2:Most active domains";
constant fetch = ({ "host", "path", "hits" });

constant fields = ({ "Domain", "Pages", "Hits" });
constant types = ({ "text", "num", "num" });

mapping display(mapping args, mapping m)
{
  object t = LogView.Table.table(m->table, fields);
  t = t->rsort("Domain")->rsort("Hits", "Pages");
  return ([ "fields":rows(mkmapping(fields, fields), indices(t)),
	    "types":rows(mkmapping(fields, types), indices(t)),
	    "table":values(t) ]);
}

mapping store(mapping m)
{
  return m;
}

mapping join(mapping m1, mapping m2)
{
  mapping m = ([]);
  m->table = values(LogView.Table.table(m1->table+m2->table, fields)->
		    sum(@fields[1..])->rsort("Hits")->
		    truncate(group_int_Max_Table_Size));
  m->total_pages = m1->total_pages + m2->total_pages;
  m->total_hits = m1->total_hits + m2->total_hits;
  return m;
}

mapping fu(array table)
{
  object t = LogView.Table.table(table, fetch);
  t = t->map_col(lambda(string host, function f, string s)
		 { return f(host, s); }, "host",
		 complete_host, log_str_Server_Domain_Name);
  t = t->map_col(lambda(string host)
		 { return reverse(reverse(host/".")[0..1])*"."; }, "host");
  t = t->map_col(lambda(string path, int hits, function f)
		{ return f(path||"")?hits:0; }, ({ "path", "hits" }),
		Regexp(log_str_Page_Regexp||"")->match);
  t = t->sum("path", "hits");
  return ([ "table":values(t),
	    "total_pages":(float)`+(0, @t->col("path")),
	    "total_hits":(float)`+(0, @t->col("hits")) ]);
}
