// LogView function

inherit "fu.pik";

constant title = "8:Download//5:Popular files";
constant fetch = ({ "path", "method", "status", "hits", "size" });

array fields = ({ "File", "Downloads", "Transferred (kb)" });
array types = ({ "page url", "num", "num" });

mapping display(string display_type, array table)
{
  object t = LogView.Table.table(table, fields);
  t = t->sort("File")->reverse()->sort("Downloads")->reverse();
  return ([ "fields":fields, "types":types, "table":values(t) ]);
}

array store(array table)
{
  return table;
}

array join(array t1, array t2)
{
  return values(LogView.Table.table(t1+t2, fields)->
		sum(@fields[1..])->rsort("Downloads")->
		truncate(group_int_Max_Table_Size));
}

array fu(array table)
{
  object t = LogView.Table.table(table, fetch);
  t = t->filter(lambda(string path, string method, int status, function f)
		{ return f(path||"") && method=="GET" && status<400; },
		({ "path", "method", "status" }),
		Regexp(log_str_Download_Files||"")->match);
  t = t->map_col(lambda(int size)
		 { return size/1024+(size%1024?1:0); }, "size");
  t = t->map_col(lambda(string path, function f)
		 { return f(path); }, "path", page_link);
  t = t->cols("path", "hits", "size")->sum("hits", "size");
  return values(t);
}
