// LogView function

inherit "fu.pik";

constant title = "8:Download//0:Download hits";
constant fetch = ({ "hour", "path", "method", "status", "hits" });

constant display_types = ({ "line chart", "bar chart" });

constant fields = ({ "Hour", "Download hits" });
constant types = ({ "text", "num" });

array store(array table)
{
  return table;
}

mapping display(string display_type, array table, array sum)
{
  for(int h = 0; h < 24; h++)
    table += ({ ({ h, 0 }) });

  object t = LogView.Table.table(table, fields)->sum("Download hits");
  t = t->map_col(lambda(int h) { return sprintf("%02d", h); }, "Hour");
  if(sum)
    t = t->not_cols("Hour")->sum("Download hits");
  else
    t = t->sort("Hour");
  return ([ "fields":rows(mkmapping(fields, fields), indices(t)),
	    "types":rows(mkmapping(fields, types), indices(t)),
	    "table":values(t) ]);
}

array join(array t1, array t2)
{
  return values(LogView.Table.table(t1+t2, fields)->sum("Download hits"));
}

array fu(array table)
{
  object t = LogView.Table.table(table, fetch);
  t = t->filter(lambda(string path, string method, int status, function f)
		{ return f(path||"") && method=="GET" && status<400; },
		({ "path", "method", "status" }),
		Regexp(log_str_Download_Files||"")->match);
  return values(t->cols("hour", "hits")->sum("hits"));
}
