// LogView function

inherit "fu.pik";

int group_int_Max_Table_Size;

constant title = "8:Maintenance//1:Error code specification";
constant fetch = ({ "Path", "Referrer", "Status", "Hits" });

mapping display(string display_type, array table)
{
  array fields = ({ "Path", "Referrer", "Return code", "Hits" });
  array types = ({ "text", "URLmaybe", "text", "num" });
  return ([ "fields":fields, "types":types, "table":table ]);
}

array store(mixed table)
{
  return max_table(reverse(array_sort(normalize(table), 3)),
		   group_int_Max_Table_Size);
}

mapping join(mixed old_table, mixed new_table)
{
  return array_acc(old_table, new_table, ({ 3 }));
}

mapping fu(mixed data)
{
  array(array) v = ({});
  data = normalize(data);
  foreach(data, array row) {
    row[2] = row[2]||200;
    switch(row[2]) {
    case 200:
    case 300..399:
      break;
    default:
      row[1] = (((row[1]||"")/"?") + ({ "" }))[0];
      v += ({ ({ row[0]||"",
		 row[1][..(sizeof("http://")-1)]=="http://"?
		   "!"+row[1]:"#"+row[1],
		 err_msgs[row[2]] || ((string) row[2]),
		 row[3] }) });
    }
  }
  return join(([]), v);
}
