// LogView function

inherit "fu.pik";

constant title = "8:Maintenance//0:Return code summary";
constant fetch = ({ "Status", "Hits" });
constant display_types = ({ "3D pie chart", "pie chart" });

mapping display(string display_type, array table)
{
  array fields = ({ "Return code", "Hits" });
  array types = ({ "text", "num" });
  return ([ "fields":fields, "types":types, "table":table ]);
}

array store(array table)
{
  return array_sort(normalize(table), 0);
}

mapping join(mixed old_table, mixed new_table)
{
  return array_acc(old_table, new_table, ({ 1 }));
}

mapping fu(mixed data)
{
  data = normalize(data);
  foreach(data, array row)
    row[0] = err_msgs[row[0]||200] || ((string) row[0]);
  return join(([]), data);
}
