// LogView function

inherit "fu.pik";

constant title = "0:Site activity//0:Hits";
constant fetch = ({ "Hour", "Hits" });
constant vues = ({ "day" });

constant display_types = ({ "line chart", "bar chart" });

mapping display(string display_type, array table, int sum)
{
  array fields = ({ "Hour", "Hits" });
  array types = ({ "text", "num" });
  if(sum)
    return ([ "fields":fields[1..], "types":types[1..],
	      "table":({ ({ (sizeof(table)?`+(@column(table,1)):0) }) }) ]);
  return ([ "fields":fields, "types":types, "table":table ]);
}

array store(mixed table)
{
  return array_sort(normalize(table), 0);
}

mapping join(mixed old_table, mixed new_table)
{
  return array_acc(old_table, new_table, ({ 1 }));
}

mapping fu(mixed data)
{
  foreach(data, array row)
    if(intp(row[0]))
      row[0] = sprintf("%02d", row[0]);
  return join(([]), data);
}
