// LogView function

inherit "fu.pik";

constant title = "6:Pathways//0:Internal links, pages";
constant fetch = ({ "Referrer", "Path", "Hits", });

mapping display(string display_type, array table)
{
  array fields = ({ "Referred from", "Referred to", "Hits" });
  array types = ({ "delta url", "text", "num" });
  return ([ "fields":fields, "types":types, "table":table ]);
}

array store(array table)
{
  mapping m = ([]), top = ([]);
  foreach(max_table(reverse(array_sort(normalize(table), 2)),
		    group_int_Max_Table_Size), array a) {
    if(m[a[0]])
      m[a[0]] += ({ a });
    else
      m[a[0]] = ({ a });
    top[a[0]] += a[2];
  }
  array a = indices(top), b = values(top);
  sort(b, a);
  array v = ({});
  foreach(reverse(a), string s)
    v += m[s];
  return v;
}

mapping join(mixed old_table, mixed new_table)
{
  return array_acc(old_table, new_table, ({ 2 }));
}

function match, ispage;
void start()
{
  match = match_multiple(log_str_Server_Domain_Name, log_str_Server_Alias);
  ispage = match_multiple(log_str_Page_Regexp);
}

mapping fu(mixed data)
{
  array v = ({});
  
  data = normalize(data);
  foreach(data, array row) {
    if(row[0] && row[1]) {
      string ref = (row[0]/"?")[0];
      row[1] = http_decode_string((row[1]/"?")[0]);
      if(sizeof(ref) && match(ref) && ispage(row[1]))
	v += ({ ({ ref, row[1], row[2] }) });
    }
  }
  return join(([]), v);
}
