// LogView function

inherit "fu.pik";

int group_int_Max_Table_Size;

constant title = "5:Visitor profiles//9:Most common browser, version & OS";
constant fetch = ({ "Client", "Hits" });

mapping display(string display_type, array table)
{
  array fields = ({ "Client", "Version", "OS", "Hits" });
  array types = ({ "text", "text", "text", "num" });
  return ([ "fields":fields, "types":types, "table":table ]);
}

array store(array table)
{
  return max_table(reverse(array_sort(normalize(table), 3)),
		   group_int_Max_Table_Size);
}

mapping join(mixed old_table, mixed new_table)
{
  return array_acc(old_table, new_table, ({ 3 }));
}

mapping fu(mixed data)
{
  data = normalize(data);
  array v = ({});
  foreach(data, array row) {
    if(row[0]) {
      mapping m = client_info(row[0]);
      v += ({ ({ m->name, m->version, m->os, row[1] }) });
    }
  }
  return join(([]), v);
}
