// LogView function

inherit "fu.pik";

constant title = "0:Site activity//0:Page load";
constant fetch = ({ "hour", "path", "method", "hits" });

constant display_types = ({ "line chart", "bar chart" });

constant fields = ({ "Hour", "Page load" });
constant types = ({ "text", "num" });

mapping display(string display_type, array table, array sum)
{
  object t = LogView.Table.table(table, fields);
  if(sum)
    t = t->not_cols("Hour")->sum("Page load");
  else
    t = t->sort("Hour");
  return ([ "fields":rows(mkmapping(fields, fields), indices(t)),
	    "types":rows(mkmapping(fields, types), indices(t)),
	    "table":values(t) ]);
}

array store(array table)
{
  return table;
}

array join(array t1, array t2)
{
  return values(LogView.Table.table(t1+t2, fields)->sum("Page load"));
}

array fu(array table)
{
  object t = LogView.Table.table(table, fetch);
  t = t->filter(lambda(string path, string method, function f)
		{ return f(path||"") && method=="GET"; },
		({ "path", "method" }),
		Regexp(log_str_Page_Regexp||"")->match);
  t = t->cols("hour", "hits")->sum("hits");
  return values(t);
}
