// LogView function

inherit "fu.pik";

int group_int_Max_Table_Size;

constant title = "1:Popular contents//6:Popular directories";
constant fetch = ({ "Path", "Hits", });

mapping display(string display_type, array table)
{
  array fields = ({ "Directory", "Hits" });
  array types = ({ "page url", "num" });
  return ([ "fields":fields, "types":types, "table":table ]);
}

array store(array table)
{
  return max_table(reverse(array_sort(normalize(table), 1)),
		   group_int_Max_Table_Size);
}

mapping join(mixed old_table, mixed new_table)
{
  return array_acc(old_table, new_table, ({ 1 }));
}

string path(string s)
{
  array(string) a = s/"/";
  return a[..(sizeof(a)-2)]*"/"+"/";
}

mapping fu(mixed data)
{
  data = normalize(data);
  foreach(data, array row)
    if(row[0])
      row[0] = page_link(path(http_decode_string(get_not_query(row[0]))));
  return join(([]), data);
}
