// LogView function

inherit "fu.pik";

constant title = "1:Popular contents//0:Popular pages";
constant fetch = ({ "Path", "Hits", "Status" });

mapping display(string display_type, array table)
{
  array fields = ({ "Page", "Hits" });
  array types = ({ "page url", "num" });
  return ([ "fields":fields, "types":types, "table":table ]);
}

array store(array table)
{
  return max_table(reverse(array_sort(normalize(table), 1)),
		   group_int_Max_Table_Size);
}

mapping join(mixed old_table, mixed new_table)
{
  return array_acc(old_table, new_table, ({ 1 }));
}

function ispage;
void start()
{
  ispage = Regexp(log_str_Page_Regexp||"")->match;
}

mapping fu(mixed data)
{
  array v = ({});
  
  data = normalize(data);
  foreach(data, array row) {
    row[0] = http_decode_string(((row[0]||"")/"?")[0]);
    switch(row[2]||200) {
    case 200:
    case 300..399:
      if(row[0] && ispage(row[0]))
	v += ({ ({ page_link(row[0]), row[1] }) });
    }
  }
  return join(([]), v);
}
