// LogView function

inherit "fu.pik";

constant title = "1:Popular contents//2:Popular pages with queries";
constant fetch = ({ "Path", "Hits", "Status" });

constant fields = ({ "Page", "Filtered Query", "Hits" });
constant types = ({ "page url", "text", "num" });

mapping display(string display_type, array table)
{
  return ([ "fields":fields, "types":types, "table":table ]);
}

array(array) store(array table)
{
  return table;
}

array(array) join(array(array) a, array(array) b)
{
  object t1 = ADT.Table.table(a, fields);
  object t2 = ADT.Table.table(b, fields);
  
  return (array)t1->append_bottom(t2)->sum("Hits")->
    rsort("Hits")->limit(group_int_Max_Table_Size);
}

function ispage;
function isquery_variable;
void start()
{
  ispage = Regexp(log_str_Page_Regexp||"")->match;
  isquery_variable = Regexp(log_str_Query_Filter_Regexp||"")->match;
}

string filter_query(string query)
{
  mapping q = extract_query(query);
  array new_query = ({});

  return (Array.map(query/"&",
		    lambda(string pair, mapping q)
		    {
		      string variable;
		      if(sscanf(pair, "%s=%*s", variable) != 2)
			return 0;
		      if(!isquery_variable(variable))
			return 0;
		      return pair;
		    }, q) - ({ 0 }))* "&";
}

// To get some performance the function below does not use the ADT.Table
// abstraction.

array(array) fu(array(array) table)
{
  array(array) t = ({});
  string query;
  string page;
  foreach(table, array row) {
    query = http_decode_string(get_query(row[0]||""));
    page  = http_decode_string(get_not_query(row[0]||""));
    
    switch(row[2]||200) {
    case 200:
    case 300..399:
      if(page && ispage(page))
	t += ({ ({ page_link(page), filter_query(query), row[1] }) });
    }
  }
  return (array)ADT.Table.table(t, fields)->
    rsort("Hits")->limit(group_int_Max_Table_Size);
}
