// LogView function

inherit "fu.pik";

int group_int_Max_Table_Size;

string log_str_Server_URL;

constant title = "7:Search//0:Search hits";
constant fetch = ({ "hour", "referrer", "hits", });

constant display_types = ({ "line chart", "bar chart" });

constant fields = ({ "Hour", "Search hits" });
constant types = ({ "text", "num" });

array store(array table)
{
  return table;
}

mapping display(string display_type, array table, array sum)
{
  for(int h = 0; h < 24; h++)
    table += ({ ({ h, 0 }) });

  object t = LogView.Table.table(table, fields)->sum("Search hits");
  t = t->map_col(lambda(int h) { return sprintf("%02d", h); }, "Hour");
  if(sum)
    t = t->not_cols("Hour")->sum("Search hits");
  else
    t = t->sort("Hour");
  return ([ "fields":rows(mkmapping(fields, fields), indices(t)),
	    "types":rows(mkmapping(fields, types), indices(t)),
	    "table":values(t) ]);
}

array join(array t1, array t2)
{
  return values(LogView.Table.table(t1+t2, fields)->sum("Search hits"));
}

array fu(array table)
{
  function is_engine = Regexp("("+indices(engines)*")|("+")")->match;
  object t = LogView.Table.table(table, fetch);
  t = t->filter(lambda(string ref, function is_engine)
		{ return (ref && sscanf(ref, "http://%s/%*s?%*s", ref) == 3 &&
			  is_engine(lower_case(ref))); },
		"referrer", is_engine);
  return values(t->cols("hour", "hits")->sum("hits"));
}
