// LogView function

inherit "fu.pik";

int group_int_Max_Table_Size;

string log_str_Server_URL;

constant title = "7:Search//2:Search phrases";
constant fetch = ({ "Referrer", "Hits", });

mapping display(string display_type, array table)
{
  array fields = ({ "Phrase", "Hits" });
  array types = ({ "text", "num" });

  object t = LogView.Table.table(table, fields);
  t = t->sort("Phrase")->reverse()->sort("Hits")->reverse();
  return ([ "fields":fields, "types":types, "table":values(t) ]);
}

array store(array table)
{
  return max_table(reverse(array_sort(normalize(table), 1)),
		   group_int_Max_Table_Size);
}

mapping join(mixed old_table, mixed new_table)
{
  return array_acc(old_table, new_table, ({ 1 }));
}

function is_engine;
void start()
{
  is_engine = Regexp("("+indices(engines)*")|("+")")->match;
}

mapping fu(mixed data)
{
  string host, q;
  mapping words = ([]);

  data = normalize(data);
  foreach(data, array row) {
    if(row[0] && sscanf(row[0], "http://%s/%*s?%s", host, q) == 3) {
      host = lower_case(host);
      mapping m = extract_query(q);
      if(m->base && m->q)
	host = "intraseek";
      if(is_engine(host)) {
	foreach(indices(engines), string s) {
	  if(search(host, s) != -1) {
	    words[replace((m[engine_q[s]]||"")[0..79], "+", " ")] += row[1];
	    break;
	  }
	}
      }
    }
  }
  return join(([]), Array.map(indices(words),lambda(string s, mapping w) {
    return ({ s, w[s] });
  }, words));
}
