// LogView function

inherit "fu.pik";

int group_int_Max_Table_Size;

constant title = "3:Visitor sessions//3:Most frequent exit pages";

constant depend = "sessions";
constant depend_type = "store";

mapping display(string display_type, array table)
{
  array fields = ({ "Exit page", "%" });
  array types = ({ "page url", "text" });

  if(sizeof(table)) {
    float sum = (float) (sizeof(table)?`+(@column(table, 1)):0);
    for(int i = 0; i < sizeof(table); i++)
      table[i][1] = sprintf("%.1f", 100.0*(float) table[i][1]/sum);
  }
  return ([ "fields":fields, "types":types, "table":table ]);
}

array store(array table)
{
  return max_table(reverse(array_sort(table, 1)), group_int_Max_Table_Size);
}

array join(array old_table, array new_table)
{
  return normalize(array_acc(old_table, new_table, ({ 1 })));
}

array fu(array data)
{
  mapping m = ([]);
  foreach(data, array a)
    if(a[7] == "OK" && match_page(a[4]))
      m[a[4]]++;
  return transpose(({ Array.map(indices(m), page_link), values(m) }));
}
