// LogView function

inherit "fu.pik";

int group_int_Max_Table_Size;

constant title = "3:Visitor sessions//0:Average hits & pages per session";
constant vues = ({ "day" });

constant display_types = ({ "line chart", "bar chart" });

constant depend = "sessions";
constant depend_type = "store";

mapping display(string display_type, array table, int sum)
{
  array fields = ({ "Hour", "Average hits", "Average pages", "Hits" });
  array types = ({ "text", "num", "num", "num" });

  object t = LogView.Table.table(table, fields);
  if(sum)
    t = t->not_cols("Hour");
  t = t->sum(@fields[1..]);
  t = t->map_col(lambda(int h, int p, int s)
		 { return ({ (float)h/(float)s,
			     (float)p/(float)s }); },
		 fields[1..]);
  t = t->not_cols("Hits")->sort("Hour");

  return ([ "fields":rows(mkmapping(fields, fields), indices(t)),
	    "types":rows(mkmapping(fields, types), indices(t)),
	    "table":values(t) ]);
}

array store(array table)
{
  return table;
}

array join(array old_table, array new_table)
{
  return normalize(array_acc(old_table, new_table, ({ 1,2,3 })));
}

array fu(array data)
{
  array table = ({});
  foreach(data, array a)
    if(a[7] == "OK")
      table += ({ ({ a[11], a[1], a[2], 1 }) });
  return join(({}), table);
}
