// Roxen LogView Summary Program
//
// Copyright (C) 1996, 1997, 1998 Informationsvvarna
//

constant gurka = spider;

/* kludge */
#define werror Stdio.stderr->write


import Array;
import Stdio;

#if __VERSION__ >= 0.6
import ".";
import "../";
#endif

string processing, msg;
object rpc, real_err;

void profile(string context)
{
#ifdef SUMMARY_PROFILE
  werror(sprintf("mem: %3.1f Mb [%s]\n",
	(float) (file_stat("/proc/"+getpid()+"/as")||({0,0}))[1]/1048576,
	context));
#endif
}

string time_and_date(int t)
{
  mapping m = localtime(t);
  return sprintf("%04d-%02d-%02d (%s) at %02d:%02d:%02d",
		 m->year+1900, m->mon+1, m->mday,
		 Calendar.day_names[(m->wday+6)%7],
		 m->hour, m->min, m->sec);
}

string time_interval(int s)
{
  return sprintf("%02d:%02d:%02d", s/3600,(s%3600)/60,s%60);
}

int start_time;
void init_time_status()
{
  start_time = time();
}
void time_status(int a, int b)
{
  int time_now = time();
  int delta = time_now-start_time;
  float r = (float)a/(float)b;
  if(r == 0.0) {
    werror(" [0%].\n");
  } else {
    int left = (int) ((float)delta/r) - delta;
    werror(sprintf(" [%d%%, %s left].\n",
		   (int)(100*r), time_interval(left)));
  }
}

string path(string s)
{
  array(string) a = s/"/";
  return a[..(sizeof(a)-2)]*"/"+"/";
}

string filename(string s)
{
  s = (s/"/")[-1];
  if(!sizeof(s))
    return 0;
  return s;
}

void import_this_server(object rpc)
{
  string ts = rpc->this_server_log();
  werror(sprintf("log: %O\n", ts));
  if(!ts || !sizeof(ts))
    return;

  string workdir = combine_path(getcwd(), "working/");
  // object dman = LogView.LogMan.log_man(combine_path(getcwd(),"logs/"),"w");
  // dman->select_db(ts);
  foreach(glob("done.*", get_dir(workdir)||({})), string db_name) {
    catch {
      object bucket = LogView.Bucket.bucket(workdir+db_name+"/log", "w");
      bucket->exception(rpc->warning);
      werror(sprintf("bundling %O", bucket->name()));
      bucket->bundle(combine_path(getcwd(),"logs/"+ts+"/log"));
      bucket = 0;
    };
    rpc->bonk();  // Check if Roxen is alive
    werror("\n");
    LogView.RmDir.rm_dir(combine_path(workdir, db_name));
  }
}

string vue_tablename(string s, string v)
{
  int y,m,d;
  sscanf(s, "%*s%d_%d_%d", y,m,d);
  string key = v+".";
  switch(v) {
  case "day":
    key += sprintf("%04d_%02d_%02d", y,m,d);
    break;
  case "week":
    int w = LogView.
      Calendar.week(y,m,d);
    if((m == 1 && w > 50) || (m == 12 && w == 1))
      w = -w;
    key += sprintf("%04d_%02d", y,w);
    break;
  case "month":
    key += sprintf("%04d_%02d", y,m);
    break;
  case "year":
    key += sprintf("%04d", y);
    break;
  }
  return key;
}

multiset revise_cache;
void revise_display(string tablename, mixed fu_info,
		    object fu, object vue_table)
{
  foreach(({ "day", "month" }), string type) {
    // foreach(({ "day", "week", "month", "year" }), string type) {
    mixed data;
    string s = vue_tablename(tablename, type);
    // werror("  - PONDERING "+s+" ["+(revise_cache[s]?"Not":"OK")+"]\n");
    if(fu->revise && !revise_cache[s] && (data = vue_table->get(s))) {
      // processing = "Data for "+s+" may have been lost!";
      vue_table->set(s, fu->revise(data));
      // processing = 0;
    }
    revise_cache[s] = 1;
  }
}

void update_display(string tablename, string db_filename, string src_table,
		    mapping status, mixed fu_info, mixed fu_data,
		    object fu, object vue_table, object|void dep_table,
		    int|void x)
{
  rpc->bonk();

  // mapping m = vue_table->get("db_index") || ([]);
  // m[db_filename] = ((m[db_filename]||({})) |  ({ src_table }));
  // processing = ("Data for ``"+status->groupname+"'', "+
  //               status->funame+" "+tablename+" may have been lost!");
  // vue_table->set("db_index", m);
  foreach(({ "day", "month" }), string type) {
    // foreach(({ "day", "week", "month", "year" }), string type) {
    // if(!fu_info->vues || (mkmultiset(fu_info->vues)[type])) {
      
      mixed data, old_data;
      string s = vue_tablename(tablename, type);
      werror(" "+type);
      if(!(dep_table && x)) {
	if(dep_table)
	  data = fu->store(fu->fu(dep_table->get(s)));
	else
	  data = copy_value(fu_data);
	if(old_data = vue_table->get(s))
	  data = fu->store(fu->join(old_data, data));
      } else
	werror(" (ign)");

      if(!(dep_table && x))
	vue_table->set(s, data);
  }
  // processing = 0;
}

void new_table(mapping new_dates, string date, array(string) tables)
{
  if(new_dates[date])
    new_dates[date] |= tables;
  else
    new_dates[date] = tables;
}

array(string) new_dbdata(string db_name, array(string) all_tables,
			 object vue_table)
{
  mapping m = vue_table->get("db_index") || ([]);
  array(string) new_tables = all_tables - (m[db_name] || ({}));
  m[db_name] = all_tables;
  vue_table->set("db_index", m);
  return new_tables;
}

void update_calendar(string group, object vue_table, object rpc)
{
  array dates = ({});
  mapping db_i = vue_table->get("db_index") || ([]);
  foreach(indices(db_i), array db_name)
    dates |= Array.map(db_i[db_name],
		       lambda(string s)
		       { int y, m, d; sscanf(s, "%d_%d_%d", y,m,d);
		         return vue_tablename(sprintf("%04d_%02d_%02d",y,m,d),
					      "day"); });

  object t = rpc->vue(group)->table("global");
  t->set("calendar", Array.uniq((t->get("calendar") || ({})) | dates));
}

mixed old_fu, old_fu_info, old_groupname, old_logname;
object query_fu(object fus, mapping fu_info,
		string|void groupname, string|void logname)
{
  if(old_fu && equal(old_fu_info, fu_info) &&
     (!groupname || (old_groupname == groupname)) &&
     (!logname || (old_logname == logname)))
    return old_fu;
  old_fu_info = copy_value(fu_info);
  old_groupname = groupname;
  old_logname = logname;
  return old_fu = fus->query_fu(fu_info,
	     (rpc->read_log_config(logname)->log_args||([]))+
	     (rpc->read_group_config(groupname)->group_args||([])));
}

mixed filter_query(object bucket, object fu, mapping fu_info,
		   string tablename)
{
  int host_column;
  array fetch = fu_info->fetch;
  string ignore_hosts = fu->group_str_Ignore_Hosts;

  if(ignore_hosts && !sizeof(ignore_hosts)) ignore_hosts = 0;

  if(ignore_hosts) {
    host_column = search(fetch, "host");
    if(host_column < 0)
      fetch += ({ "host" });
  }

  int path_column;
  string ignore_pages = fu->group_str_Ignore_Pages;
  if(ignore_pages && !sizeof(ignore_pages)) ignore_pages = 0;

  if(ignore_pages) {
    path_column = search(fetch, "path");
    if(path_column < 0)
      fetch += ({ "path" });
  }
  
  array(string) sum_by = fu_info->as_is?0:(({"size","hits"})&fu_info->fetch);
  array(array) data = bucket->query(tablename, fetch, sum_by);

  // The order of the too folowing sections are important
  // (removal of extra collumns).
  if(ignore_pages)
    data = fu->ignore_pages(data, path_column);

  if(ignore_hosts)
    data = fu->ignore_hosts(data, host_column);

  return data;
}

static private mapping Bucket_cache = ([]);
object Bucket_Manager(string logfile)
{
  object bucket = Bucket_cache[logfile] || LogView.Bucket.bucket(logfile);
  bucket->exception(rpc->warning);
  return Bucket_cache[logfile] = bucket;
}

mapping update_fu(string funame, mapping status)
{
  // werror(sprintf("  fu: %O\n", funame));
  object fus = Fu.fu(rpc->get_fu_directory());
  
  if(status[funame]) {
    // werror(" is already done.\n");
    return status;
  } else
    status[funame] = ([]);
  mapping fu_status = status[funame];

  mapping fu_info = fus->load_fu(funame);
  if(!fu_info) {
    werror(" is gone!\n");
    return status;
  }
  if(fu_info->depend) {
    // werror(sprintf("  fu: %O depends on %O.\n", funame, fu_info->depend));
    status = update_fu(fu_info->depend, status);
  }

  status->funame = funame;
  multiset(string) dirty_tables = (<>);
  mapping fu_info = fus->load_fu(funame);
  if(!fu_info->fetch) {
    werror(funame+" does not contain 'fetch'. Aborted.\n");
    return status;
  }

  /* Check new dates */
  object o_vue_table = rpc->vue(status->groupname)->table(funame);
  object vue_table = o_vue_table->transaction();

  mapping new_tables = ([]);
  foreach(status->dbs, string db_filename)
    new_tables[db_filename] = new_dbdata(db_filename,
					 status->db_tables[db_filename],
					 vue_table);
  int new_units = 0;
  mapping new_days = ([]);
  foreach(indices(new_tables), string db_filename) {
    foreach(new_tables[db_filename], string table) {
      new_units++;
      string day = vue_tablename(table, "day");
      if(new_days[day])
	new_days[day] |= ({ db_filename+"\0"+table });
      else
	new_days[day] = ({ db_filename+"\0"+table });
    }
  }
  
  werror(sprintf("  fu: %O\n", rpc->fu_title(funame)));
  if(!sizeof(new_days)) {
    o_vue_table->close();
    return status;
  }
  
  int n = 0;
  init_time_status();

  revise_cache = (<>);   // Clear revise cache
  if(fu_info->depend) {
    /* Depending days */
    object dep_table = rpc->vue(status->groupname)->table(fu_info->depend);
    foreach(sort(indices(new_days)), string day) {
      revise_display(day, fu_info, query_fu(fus, fu_info), vue_table);
      int x = 0;
      foreach(sort(new_days[day]), string tablename) {
	array(string) db_table = tablename/"\0";
	object fu = query_fu(fus, fu_info, status->groupname, db_table[0]);
	werror(sprintf("    dep: %O", db_table[1]));
	update_display(day, @db_table, status,
		       fu_info, 0, fu, vue_table, dep_table, x++);
	werror(" ok");
	time_status(n++, new_units);
	// break;  /* Do NOT process more tables! */
      }
    }
  } else {
    /* Processing days */
    foreach(sort(indices(new_days)), string day) {
      revise_display(day, fu_info, query_fu(fus, fu_info), vue_table);
      foreach(sort(new_days[day]), string tablename) {
	array(string) db_table = tablename/"\0";
	object fu = query_fu(fus, fu_info, status->groupname, db_table[0]);
	werror(sprintf("    proc: %O", db_table[1]));
	object bucket = Bucket_Manager("logs/"+db_table[0]+"/log");
	mixed fu_data = fu->fu(filter_query(bucket,fu,fu_info,db_table[1]));
	update_display(day, @db_table, status,
		       fu_info, fu->store(fu_data), fu, vue_table);
	werror(" ok");
	time_status(n++, new_units);
      }
    }
  }
  profile(funame);

  update_calendar(status->groupname, vue_table, rpc);
  vue_table->commit();
  vue_table->sync();
  o_vue_table->close();
  rpc->clear_query_cache();
  return status;
}

void update_fus(string groupname, object rpc)
{
  mapping status = ([]);
  array a = values(rpc->read_group_config(groupname)->logs);
  status->dbs = sizeof(a)?a[0]:({});
  status->groupname = groupname;
  status->group_data_dates = ({});

  status->db_tables = ([]);
  foreach(status->dbs, string db_filename) {
    // object dman = LogView.LogMan.log_man("logs/"+path(db_filename));
    // dman->select_db(filename(db_filename));
    // status->db_tables[db_filename] = dman->list_tables();
    status->db_tables[db_filename] = 
      indices(Bucket_Manager("logs/"+db_filename+"/log"));
  }

  // rpc->vue(groupname)->rollback();
  foreach(rpc->read_group_config(groupname)->fugroups||({}), string fugroup)
    foreach(rpc->list_fufilenames(fugroup), string funame)
      status = update_fu(funame, status);
}

int main2(int argc, array(string) argv)
{
  real_err = Stdio.stderr->dup();
  Stdio.stderr->assign( Stdio.File( "summary.out", "wct" ));
  add_constant("werror", Stdio.stderr->write);
  
  int starttime = time();
  string s = sprintf("(LogView Summary) ``"+rpc->virtual_name()+
		     "''. Starting %s [pid %d].\n",
		     time_and_date(starttime), getpid());
  real_err->write(s);
  werror(s);
  rpc->notice(s);

  /* Renice process if wanted. */
  for(int i = rpc->get_nice_value(); i > 0; i--)
    nice(1);
  
  /* Import Common Log files */
  werror(sprintf("*** Importing Common Log files ***\n"));
  mapping m = rpc->clf_imports();
  foreach(indices(m), string log_file) {
    if(rpc->read_log_config(log_file)->status) {
      werror(sprintf("file: %O -> %O\n", m[log_file], log_file));
      LogView.ImportCLF.import_clf(getcwd(), m[log_file], log_file, rpc);
    } else
      werror(sprintf("file: %O -> %O DISABLED\n", m[log_file], log_file));
  }
  
  /* Import this_server log files */
  werror(sprintf("*** Updating local server ***\n"));
  import_this_server(rpc);
  
  profile("start");
  /* Update statistics databases */
  object sql;
  catch { sql = rpc->sql(); };
  werror(sprintf("*** Updating statistics databases ***\n"));
  foreach(rpc->list_groups(), string groupname) {
    werror(sprintf("group: %O\n", groupname));
    update_fus(groupname, rpc);

    if(sql) {
      if(mkmultiset(rpc->read_main_config()->sql_exports||({}))[groupname]) {
	werror("  *** Updating SQL tables ***\n");
	foreach(rpc->read_group_config(groupname)->fugroups||({}),
		string fugroup)
	  foreach(rpc->list_fufilenames(fugroup), string funame)
	    ExportSQL.export_sql(sql)->export(groupname, funame,
					      rpc->vue(groupname), rpc);
	werror("  *** SQL Done ***\n");
      }
    }
  }
  profile("end");
  
  rpc->remove_friendly_lock();
  
  int endtime = time();
  string s = sprintf("(LogView Summary) ``"+rpc->virtual_name()+
		     "''. Done %s [took %s].\n",
		     time_and_date(endtime), time_interval(endtime-starttime));
  werror(s);
  real_err->write(s);
  rpc->notice(s);
}

void eject(int|void x)
{
  string w = (processing?"Warning: "+processing+"\n":"");
  msg = ("(LogView Summary) Terminated"+(x==42?" OK":"")+
	 ". Reason unknown.\n"+w);
  if(x == 42)
    catch {
      msg = ("(LogView Summary) ``"+rpc->virtual_name()+"''. "
	     "Exiting"+(x==42?" OK":"")+". "+rpc->exit_msg()+"\n"+w);
      werror("\n"+msg);
      real_err->write(msg);
      rpc->notice(msg);
      kill(getpid(), 9);
    };
  real_err->write(msg);
  werror("\n"+msg);
  kill(getpid(), 9);
}

int main(int argc, array(string) argv)
{
  array cmd = decode_value(MIME.decode_base64(argv[1]));
  if(!(rpc = RoxenRPC.Client(@cmd))) {
    werror("(LogView Summary) Could not connect to RoxenRPC server.\n");
    return 0;
  }
  rpc->bonk();

  master()->add_module_path(combine_path(__FILE__, "../../"));
  foreach( ({ "USR1", "USR2", "TERM", "HUP", "INT", "QUIT" }), string sig)
    catch { signal(signum("SIG"+sig), eject); };

  mixed err;
  if(err = catch(main2(argc, argv))) {
    string w = (processing?"<b>WARNING: "+processing+"</b>\n":"");
    catch {
      if(glob("*#bonk*", err[0]))
      eject(42);
    };
    catch {
      if(glob("*/RoxenRPC.pmod/Client.pike", err[-1][-1][0]) &&
	 !glob("Remote error:*", err[0])) {
	werror("(LogView Summary) Exiting. RPC server "
	       "(Roxen) disconnected.\n"+w);
	kill(getpid(), 9);
      }
    };
    array a = master()->describe_backtrace(err)/"\n";
    a[0] = "<b>"+a[0]+"</b>";
    msg = a*"\n"+w;
    real_err->write("(LogView Summary) Terminated. Reason unknown.\n"+w);
    werror("\n"+msg);
    catch { rpc->warning("(LogView Summary) "+msg); };
    kill(getpid(), 9);
  }

  return 0;
}
