
inherit "wizard";
inherit "wiz.pik";

constant name = "41:Rebuild group...";
constant doc = "Delete only the contents of the statistics group database.";

mapping parse_config(object id, object o)
{
  array a = ({});
  foreach(glob("group_*", indices(id->variables)), string name)
    if(id->variables[name] != "0")
      a += ({ name[sizeof("group_")..] });
  return ([ "groups":a ]);
}

string page_0(object id, object o)
{
  string r = "";
  array groups = o->list_groups();

  r += "Only the database of the statistics group will be deleted.\n"
       "LogView will continue to read data from the logs attached\n"
       "to the statistics group.<p>\n";

  if(sizeof(groups)) {
    r += "Select groups to rebuild.<p>";
    
    array a = ({});
    foreach(groups, string name) {
      a += ({ ({ "<font size=-1><var name='group_"+name+"' type=checkbox "
		   "value=ok></font> "+name,
		   mb_size(o->group_size(name)) }) });
    }
    r += html_table(({ "Group", "Size (Mb)" }), a);
  } else
    r += "<em>No groups are available.</em>";
  
  return r;
}

string page_1(object id, object o)
{
  string r = "";
  array(string) a = parse_config(id, o)->groups;
  array b = copy_value(a);
  for(int i = 0; i < sizeof(b); i++)
    b[i] = "<b>"+b[i]+"</b>";
  if(sizeof(b) > 1)
    b = b[0..(sizeof(b)-3)] + ({ b[-2]+" and "+b[-1] });

  if(sizeof(a))
    r += "Are you sure you want to rebuild "+b*", "+"?<p>";
  else
    r += "<em>No groups were selected.</em><p>";
  
  return r;
}

void rm_group(array groups, object o)
{
  foreach(groups, string name)
    o->purge_group(name);
  if(sizeof(groups) == 1)
    o->notice("Group "+String.implode_nicely(groups)+" is purged.");
  else if(sizeof(groups) > 1)
    o->notice("Groups "+String.implode_nicely(groups)+" are purged.");
}

void wizard_done(object id, object o)
{
  array groups = parse_config(id, o)->groups;
  if(sizeof(groups))
    o->exit_update("Database"+(sizeof(groups)>1?"s":"")+" purged.",
		   rm_group, groups, o);
}
