
inherit "wizard";
inherit "wiz.pik";

constant name = "31:Reset log...";
constant doc = "Delete only the contents of the log.";

mapping parse_config(object id, object o)
{
  array a = ({});
  foreach(glob("log_*", indices(id->variables)), string name)
    if(id->variables[name] != "0")
      a += ({ name[sizeof("log_")..] });
  return ([ "logs":a ]);
}

string page_0(object id, object o)
{
  string r = "";

  r += "Only the contents of the log will be deleted and\n"
       "the log configuration will be kept. LogView will continue "
       "to extract statistics from the log in the future.<p>\n";
  
  array local_logs = o->list_logs();
  if(sizeof(local_logs)) {
    r += "Select logs to reset.<p>";
    array a = ({});
    foreach(local_logs, string name) {
      a += ({ ({ "<font size=-1><var name='log_"+name+"' type=checkbox "
		 "value=ok></font> "+name, mb_size(o->log_size(name)) }) });
    }
    r += html_table(({ "Group", "Size (Mb)" }), a);
  } else
    r += "<em>No logs are available.</em>";
  
  return r;
}

string page_1(object id, object o)
{
  string r = "";
  array a = parse_config(id, o)->logs;
  array b = copy_value(a);
  for(int i = 0; i < sizeof(b); i++)
    b[i] = "<b>"+b[i]+"</b>";
  if(sizeof(b) > 1)
    b = b[0..(sizeof(b)-3)] + ({ b[-2]+" and "+b[-1] });

  if(sizeof(a))
    r += "Are you sure you want to reset "+b*", "+"?<p>";
  else
    r += "<em>No logs were selected.</em><p>";
  
  return r;
}

void rm_log(array logs, object o)
{
  foreach(logs, string name)
      o->purge_log(name);
  if(sizeof(logs) == 1)
    o->notice("Log "+String.implode_nicely(logs)+" is purged.");
  else if(sizeof(logs) > 1)
    o->notice("Logs "+String.implode_nicely(logs)+" are purged.");
}

void wizard_done(object id, object o)
{
  array logs = parse_config(id, o)->logs;
  if(sizeof(logs))
    o->exit_update("Log"+(sizeof(logs)>1?"s":"")+" purged.", rm_log, logs, o);
}
