
inherit "wizard";
inherit "wiz.pik";

constant name = "32:Delete log...";
constant doc = "Delete the log and forget it altogether.";

mapping parse_config(object id, object o)
{
  array a = ({});
  foreach(glob("log_*", indices(id->variables)), string name)
    if(id->variables[name] != "0")
      a += ({ name[sizeof("log_")..] });
  return ([ "logs":a ]);
}

string page_0(object id, object o)
{
  string r = "";

  r += "The contents of the log and its configuration will be deleted.\n"
       "LogView will no longer use this log.<p>\n";

  array local_logs = o->list_logs();
  if(sizeof(local_logs)) {
    r += "Select logs to delete.<p>";
    array a = ({});
    foreach(local_logs, string name) {
      a += ({ ({ "<font size=-1><var name='log_"+name+"' type=checkbox "
		 "value=ok></font> "+name, mb_size(o->log_size(name)) }) });
    }
    r += html_table(({ "Group", "Size (Mb)" }), a);
  } else
    r += "<em>No logs are available.</em>";
  
  return r;
}

string page_1(object id, object o)
{
  string r = "";
  array a = parse_config(id, o)->logs;
  array b = copy_value(a);
  for(int i = 0; i < sizeof(b); i++)
    b[i] = "<b>"+b[i]+"</b>";
  if(sizeof(b) > 1)
    b = b[0..(sizeof(b)-3)] + ({ b[-2]+" and "+b[-1] });

  if(sizeof(a))
    r += "Are you sure you want to delete "+b*", "+"?<p>";
  else
    r += "<em>No logs were selected.</em><p>";
  
  return r;
}

void rm_log(array logs, object o)
{
  foreach(logs, string name)
    o->rm_log(name);
  if(sizeof(logs) == 1)
    o->notice("Log "+String.implode_nicely(logs)+" is deleted.");
  else if(sizeof(logs) > 1)
    o->notice("Logs "+String.implode_nicely(logs)+" are deleted.");
}

void wizard_done(object id, object o)
{
  array logs = parse_config(id, o)->logs;
  if(sizeof(logs))
    o->exit_update("Log"+(sizeof(logs)>1?"s":"")+" deleted.", rm_log, logs, o);
}
