
inherit "wizard";
inherit "wiz.pik";

constant name = "73:Delete report...";
constant doc = "Delete reports.";

array parse_reports(object id)
{
  array a = ({});
  foreach(glob("report_*", indices(id->variables)), string name)
    if(id->variables[name] != "0")
      a += ({ (id->variables[name]/"\0")[0] });
  return a;
}

string page_0(object id, object o)
{
  string r = "";

  r += "Please select a report to delete.<p>\n";

  int i = 0;
  array v = ({});
  mapping reports = o->read_main_config()->reports || ([]);
  if(!sizeof(reports)) {
    return "<em>No reports are available.</em>";
  } else {
    foreach(sort(indices(reports)), string name)
      v += ({ ({ "<font size=-1><var name=report_"+(i++)+" type=checkbox "+
		 "value='"+name+"'></font> "+name }) });
    r += html_table(({ "Report" }), v);
  }

  return r;
}

string page_1(object id, object o)
{
  string r = "";

  array reports = parse_reports(id);
  if(sizeof(reports))
    r += ("Are you sure you want to delete "+
	  Array.map(reports, lambda(string s)
			     { return "<b>"+s+"</b>"; })*", "+"?<p>");
  else
    r += "<em>No reports were selected.</em><p>";
  return r;
}

void wizard_done(object id, object o)
{
  mapping mc = o->read_main_config();
  mc->reports = mc->reports || ([]);
  mc->email_service = mc->email_service || ([]);
  foreach(parse_reports(id), string name) {
    m_delete(mc->reports, name);
    mc->report_descriptions && m_delete(mc->report_descriptions, name);
    m_delete(mc->email_service, name);
  }
  o->save_main_config(mc);
}
