#!/usr/local/bin/pike

import Array;

array(string) months = ({ "", "Jan", "Feb", "Mar", "Apr", "May", "Jun",
			      "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" });

array(string) fields = ({ "host", "referrer", "authuser",
     "year", "month", "date", "hour", "minute",
     "second", "timezone", "method", "path",
     "protocol", "status", "size" });

void main(int argc, array(string) argv)
{
  if(argc < 2 || argc > 3) {
    werror(argv[0]+": <LogView file> [Common Log file]\n");
    return;
  }

  string log_name = argv[1];
  object file = Stdio.File();
  if(argc > 2) {
    string clf_name = argv[2];
    if(!file->open(clf_name, "wct")) {
      werror(argv[0]+": Cannot open file '"+clf_name+"'\n");
      return;
    }
  } else
    file = Stdio.stdout;
  
  object log = LogView.Bucket.bucket(log_name);
  foreach(indices(log), string table) {
    array(int) s_cols = ({ 0,1,2,10,11,12,14 });
    array data = log->query(table, fields);

    foreach(data, array(int|string) row) {
      foreach(s_cols, int i)
	if(!row[i] || (stringp(row[i]) && !sizeof(row[i])))
	  row[i] = "-";
	 
      switch("roxen") {
      case "apache":
	file->write(row[0..2]*" "+" "+
		    sprintf("[%02d/%02d/%d:%02d:%02d:%02d %s%04d] "
			    "\"%s %s %s\" %d %s\n",
			    row[5], row[4], row[3], @row[6..8],
		            (row[9]<0?"-":"+"),row[9],
		            @row[10..13], (string)row[14]));
	break;
      case "roxen":
      default:
	file->write(row[0..2]*" "+" "+
		    sprintf("[%02d/%s/%d:%02d:%02d:%02d %s%04d] "
			    "\"%s %s %s\" %d %s\n",
			    row[5], months[row[4]], row[3], @row[6..8],
			    (row[9]<0?"-":"+"),row[9],
			    @row[10..13], (string)row[14]));
      }
    }
  }
  file->close();
}
