/* This program copies all log entries from the source log
 * that are not present in the target log.
 *
 * Usage: roxen-pike merge <source log> <target log>
 */


int main(int argc, array(string) argv)
{
  array(string) fields = ({ "host", "referrer", "authuser", "year", "month",
			    "date", "hour", "minute", "second", "timezone",
			    "method", "path", "protocol", "status", "size",
			    "client", "userid" });

  LogView.Bucket.bucket source = LogView.Bucket.bucket(argv[1]+"/log", "r");
  LogView.Bucket.bucket target = LogView.Bucket.bucket(argv[2]+"/log", "r");
#if 0
  write("%O\n", sort(Array.uniq(Array.map(indices(source)-indices(target),
					  lambda(string s)
					  {
					    return sscanf(s, "%s:", s),s;
					  }))));
#endif
  foreach(sort(indices(source)-indices(target)), string entry) {
    write("copying %O...\n", entry);
    target = LogView.Bucket.bucket(argv[2]+"/log", "wc", entry, fields);
    foreach(source->query(entry, fields), array row)
      target->add(row);
    target->bundle();
  }
  return 0;
}
